
TARGETOS=WINNT

!include <ntwin32.mak>

opengllibs	= opengl32.lib glu32.lib glaux.lib

tcllibs     = tcl81.lib tk81.lib tclstub81.lib tkstub81.lib 

cruntimelibs = libci.lib libcimt.lib msvcirt.lib

tclincpath  = -I".\wintcl\include"

PACKAGE     = XmdvTool
VERSION     = 4.0R1

.SUFFIXES:
.SUFFIXES: .cpp .obj

all: XmdvTool

OBJS   = \
	colormap.obj \
	ogl.obj \
	okcdata.obj \
	brush.obj \
	parcoord.obj \
	scatter.obj \
	glyph.obj \
	glyph_place.obj \
	dimstack.obj \
	brush_oper.obj \
	cluster.obj \
	cluster_parcoord.obj \
	cluster_scatter.obj \
	cluster_glyph.obj \
	cluster_dimstack.obj \
	cluster_hist.obj \
	cluster_nav.obj \
	treemap.obj \
	magnify.obj \
	stats.obj \
	multi_select.obj \
	glyphtool.obj \
	stacktool.obj \
	parcoordtool.obj \
	XmdvTool.obj \
	togl.obj

togl.obj: togl/togl.c
    $(cc) $(cflags) $(cdebug) $(cvars) /Fm $(tclincpath) -I.\togl togl/togl.c

.cpp.obj:
    $(cc) $(cflags) $(cdebug) $(cvars) /Fm $(tclincpath) $<

XmdvTool: $(OBJS)
    $(link) $(linkdebug) $(guiflags) -subsystem:windows -entry:mainCRTStartup -out:$*.exe $(OBJS) $(tcllibs) $(opengllibs) $(cruntimelibs) $(guilibs)
