#############################################################################
# Visual Tcl v1.20 Project
#

#################################
# GLOBAL VARIABLES
#
global Doublebuffer; 
global FontName; 
global FontSize; 
global brBrushOpType; 
global brType_1; 
global brType_2; 
global brType_3; 
global brType_4; 
global br_brush; 
global brushed_radius; 
global bt_average; 
global bt_not; 
global bt_values; 
global cluster_radius; 
global conjunc; 
global extent_scaling_fac; 
global fade_factor; 
global glyph_placement_increase; 
global glyph_placement_kind; 
global glyph_placement_shift; 
global glyph_placement_space; 
global mask_brush; 
global mask_brushed_data; 
global mask_unbrushed_data; 
global show_bands; 
global t_filename; 
global widget; 
    set widget(AboutDialog) {.top27}
    set widget(AuxillaryDisplayDialog) {.top33}
    set widget(AuxillaryDisplayFrame) {.top33.fra34}
    set widget(BirchDialog) {.top24}
    set widget(BirchDialogText) {.top24.cpd26.03}
    set widget(BrushDialog) {.top19}
    set widget(BrushOperationDialog) {.top21}
    set widget(BrushToolboxDialog) {.top28}
    set widget(CanvasFrame) {.top17.fra20.fra19}
    set widget(CanvasScrollHoriz) {.top17.fra20.scr24}
    set widget(CanvasScrollVert) {.top17.fra20.scr17}
    set widget(ClusterHierarchyDialog) {.top40}
    set widget(ColorSelCanvas) {.top18.fra17.fra19.03}
    set widget(ColorSelCanvasFrame) {.top18.fra17.fra19.03.04}
    set widget(ConsoleCaption) {.top17.fra20.fra18.lab17}
    set widget(ConsoleFrame) {.top17.fra18}
    set widget(DataFieldsCanvas) {.top26.fra28.fra58.03}
    set widget(DataSummaryDialog) {.top26}
    set widget(DataValuesDialog) {.top34}
    set widget(DataValuesText) {.top34.01.02.05}
    set widget(DimStackBrushDialog) {.top30}
    set widget(DimStackKeyDialog) {.top32}
    set widget(DimStackKeyText) {.top32.fra31.fra36.03}
    set widget(DynamicMaskingScale) {.top40.fra20.fra24.sca26}
    set widget(GlyphKeyDialog) {.top23}
    set widget(GlyphKeyText) {.top23.fra26.fra28.03}
    set widget(GlyphPlacementDialog) {.top25}
    set widget(GlyphToolboxDialog) {.top39}
    set widget(GlyphToolboxFrame) {.top39.fra40}
    set widget(HelpDialog) {.top22}
    set widget(HelpText) {.top22.cpd24.03}
    set widget(HtmlHelpDialog) {.top29}
    set widget(HtmlHelpText) {.top29.fra30.cpd33.03}
    set widget(InterfaceColorDialog) {.top18}
    set widget(MainWindow) {.top17}
    set widget(MenuFrame) {.top17.fra19}
    set widget(ParallelCoordBrushDialog) {.top31}
    set widget(ParallelCoordBrushFrame) {.top31.fra33}
    set widget(StackToolboxFrame) {.top30.01}
    set widget(StructBrushFrame) {.top40.fra40.fra41}
    set widget(b_background) {.top18.fra17.fra19.03.04.08}
    set widget(b_brush1) {.top18.fra17.fra19.03.04.027}
    set widget(b_brush2) {.top18.fra17.fra19.03.04.028}
    set widget(b_brush3) {.top18.fra17.fra19.03.04.029}
    set widget(b_brush4) {.top18.fra17.fra19.03.04.030}
    set widget(b_data) {.top18.fra17.fra19.03.04.012}
    set widget(b_dimstack) {.top17.fra20.fra41.but45}
    set widget(b_glyphs) {.top17.fra20.fra41.but43}
    set widget(b_grid1) {.top18.fra17.fra19.03.04.011}
    set widget(b_grid2) {.top18.fra17.fra19.03.04.010}
    set widget(b_grid3) {.top18.fra17.fra19.03.04.09}
    set widget(b_hierarchical) {.top17.fra20.fra41.but18}
    set widget(b_highlight) {.top18.fra17.fra19.03.04.013}
    set widget(b_overlap) {.top18.fra17.fra19.03.04.014}
    set widget(b_paint) {.top18.fra17.fra19.03.04.015}
    set widget(b_parcoord) {.top17.fra20.fra41.but42}
    set widget(b_sbb) {.top18.fra17.fra19.03.04.but18}
    set widget(b_scatter) {.top17.fra20.fra41.but44}
    set widget(b_stat1) {.top18.fra17.fra19.03.04.07}
    set widget(b_stat2) {.top18.fra17.fra19.03.04.06}
    set widget(b_text) {.top18.fra17.fra19.03.04.05}
    set widget(bandsToggle) {.top40.fra20.fra27.che28}
    set widget(brActive_1) {.top28.fra43.fra18.but19}
    set widget(brActive_2) {.top28.fra43.fra17.01}
    set widget(brActive_3) {.top28.fra43.fra19.01}
    set widget(brActive_4) {.top28.fra43.fra20.01}
    set widget(brDisplay_1) {.top28.fra43.fra18.but21}
    set widget(brDisplay_2) {.top28.fra43.fra17.03}
    set widget(brDisplay_3) {.top28.fra43.fra19.03}
    set widget(brDisplay_4) {.top28.fra43.fra20.03}
    set widget(brEnable_1) {.top28.fra43.fra18.but20}
    set widget(brEnable_2) {.top28.fra43.fra17.02}
    set widget(brEnable_3) {.top28.fra43.fra19.02}
    set widget(brEnable_4) {.top28.fra43.fra20.02}
    set widget(hackFrame) {.top75.fra76}
    set widget(histoFrame) {.top40.fra40.fra46}
    set widget(l_filename) {.top26.fra28.fra46.lab17}
    set widget(l_text) {.top18.cpd20.03.fra27.01.02}
    set widget(list_BrushOps) {.top28.fra46.cpd17.01}
    set widget(m_auxillarydisplay) {.top33.men37}
    set widget(m_dependent_dims) {.top40.fra20.fra17.men18}
    set widget(rev,.top17) {MainWindow}
    set widget(rev,.top17.fra18) {ConsoleFrame}
    set widget(rev,.top17.fra19) {MenuFrame}
    set widget(rev,.top17.fra20.fra18.ent19) {ConsoleCaption}
    set widget(rev,.top17.fra20.fra18.lab17) {ConsoleCaption}
    set widget(rev,.top17.fra20.fra19) {CanvasFrame}
    set widget(rev,.top17.fra20.fra41.but18) {b_hierarchical}
    set widget(rev,.top17.fra20.fra41.but42) {b_parcoord}
    set widget(rev,.top17.fra20.fra41.but43) {b_glyphs}
    set widget(rev,.top17.fra20.fra41.but44) {b_scatter}
    set widget(rev,.top17.fra20.fra41.but45) {b_dimstack}
    set widget(rev,.top17.fra20.scr17) {CanvasScrollVert}
    set widget(rev,.top17.fra20.scr24) {CanvasScrollHoriz}
    set widget(rev,.top18) {InterfaceColorDialog}
    set widget(rev,.top18.cpd20.03) {ColorSelCanvas}
    set widget(rev,.top18.cpd20.03.fra27) {ColorSelCanvasFrame}
    set widget(rev,.top18.cpd20.03.fra27.01) {b_text}
    set widget(rev,.top18.cpd20.03.fra27.01.02) {l_text}
    set widget(rev,.top18.cpd20.03.fra27.010) {b_highlight}
    set widget(rev,.top18.cpd20.03.fra27.011) {b_overlap}
    set widget(rev,.top18.cpd20.03.fra27.012) {b_paint}
    set widget(rev,.top18.cpd20.03.fra27.03) {b_stat2}
    set widget(rev,.top18.cpd20.03.fra27.04) {b_stat1}
    set widget(rev,.top18.cpd20.03.fra27.05) {b_background}
    set widget(rev,.top18.cpd20.03.fra27.06) {b_grid3}
    set widget(rev,.top18.cpd20.03.fra27.07) {b_grid2}
    set widget(rev,.top18.cpd20.03.fra27.08) {b_grid1}
    set widget(rev,.top18.cpd20.03.fra27.09) {b_data}
    set widget(rev,.top18.cpd20.03.fra29) {ColorSelCanvasFrame}
    set widget(rev,.top18.cpd20.03.fra29.01) {b_text}
    set widget(rev,.top18.cpd20.03.fra29.010) {b_overlap}
    set widget(rev,.top18.cpd20.03.fra29.011) {b_paint}
    set widget(rev,.top18.cpd20.03.fra29.02) {b_stat2}
    set widget(rev,.top18.cpd20.03.fra29.03) {b_stat1}
    set widget(rev,.top18.cpd20.03.fra29.04) {b_background}
    set widget(rev,.top18.cpd20.03.fra29.05) {b_grid3}
    set widget(rev,.top18.cpd20.03.fra29.06) {b_grid2}
    set widget(rev,.top18.cpd20.03.fra29.07) {b_grid1}
    set widget(rev,.top18.cpd20.03.fra29.08) {b_data}
    set widget(rev,.top18.cpd20.03.fra29.09) {b_highlight}
    set widget(rev,.top18.cpd20.03.fra31) {ColorSelCanvasFrame}
    set widget(rev,.top18.cpd20.03.fra31.01) {b_text}
    set widget(rev,.top18.cpd20.03.fra31.010) {b_overlap}
    set widget(rev,.top18.cpd20.03.fra31.011) {b_paint}
    set widget(rev,.top18.cpd20.03.fra31.02) {b_stat2}
    set widget(rev,.top18.cpd20.03.fra31.03) {b_stat1}
    set widget(rev,.top18.cpd20.03.fra31.04) {b_background}
    set widget(rev,.top18.cpd20.03.fra31.05) {b_grid3}
    set widget(rev,.top18.cpd20.03.fra31.06) {b_grid2}
    set widget(rev,.top18.cpd20.03.fra31.07) {b_grid1}
    set widget(rev,.top18.cpd20.03.fra31.08) {b_data}
    set widget(rev,.top18.cpd20.03.fra31.09) {b_highlight}
    set widget(rev,.top18.cpd20.03.fra43) {ColorSelCanvasFrame}
    set widget(rev,.top18.cpd20.03.fra43.01) {b_text}
    set widget(rev,.top18.cpd20.03.fra43.010) {b_overlap}
    set widget(rev,.top18.cpd20.03.fra43.011) {b_paint}
    set widget(rev,.top18.cpd20.03.fra43.02) {b_stat2}
    set widget(rev,.top18.cpd20.03.fra43.023) {b_brush1}
    set widget(rev,.top18.cpd20.03.fra43.024) {b_brush2}
    set widget(rev,.top18.cpd20.03.fra43.025) {b_brush3}
    set widget(rev,.top18.cpd20.03.fra43.026) {b_brush4}
    set widget(rev,.top18.cpd20.03.fra43.03) {b_stat1}
    set widget(rev,.top18.cpd20.03.fra43.04) {b_background}
    set widget(rev,.top18.cpd20.03.fra43.05) {b_grid3}
    set widget(rev,.top18.cpd20.03.fra43.06) {b_grid2}
    set widget(rev,.top18.cpd20.03.fra43.07) {b_grid1}
    set widget(rev,.top18.cpd20.03.fra43.08) {b_data}
    set widget(rev,.top18.cpd20.03.fra43.09) {b_highlight}
    set widget(rev,.top18.fra17.fra19.03) {ColorSelCanvas}
    set widget(rev,.top18.fra17.fra19.03.04) {ColorSelCanvasFrame}
    set widget(rev,.top18.fra17.fra19.03.04.010) {b_grid2}
    set widget(rev,.top18.fra17.fra19.03.04.011) {b_grid1}
    set widget(rev,.top18.fra17.fra19.03.04.012) {b_data}
    set widget(rev,.top18.fra17.fra19.03.04.013) {b_highlight}
    set widget(rev,.top18.fra17.fra19.03.04.014) {b_overlap}
    set widget(rev,.top18.fra17.fra19.03.04.015) {b_paint}
    set widget(rev,.top18.fra17.fra19.03.04.027) {b_brush1}
    set widget(rev,.top18.fra17.fra19.03.04.028) {b_brush2}
    set widget(rev,.top18.fra17.fra19.03.04.029) {b_brush3}
    set widget(rev,.top18.fra17.fra19.03.04.030) {b_brush4}
    set widget(rev,.top18.fra17.fra19.03.04.05) {b_text}
    set widget(rev,.top18.fra17.fra19.03.04.06) {b_stat2}
    set widget(rev,.top18.fra17.fra19.03.04.07) {b_stat1}
    set widget(rev,.top18.fra17.fra19.03.04.08) {b_background}
    set widget(rev,.top18.fra17.fra19.03.04.09) {b_grid3}
    set widget(rev,.top18.fra17.fra19.03.04.but18) {b_sbb}
    set widget(rev,.top19) {BrushDialog}
    set widget(rev,.top21) {BrushOperationDialog}
    set widget(rev,.top22) {HelpDialog}
    set widget(rev,.top22.cpd24.03) {HelpText}
    set widget(rev,.top23) {GlyphKeyDialog}
    set widget(rev,.top23.cpd29.03) {GlyphKeyText}
    set widget(rev,.top23.fra26.fra28.03) {GlyphKeyText}
    set widget(rev,.top24) {BirchDialog}
    set widget(rev,.top24.cpd26.03) {BirchDialogText}
    set widget(rev,.top25) {GlyphPlacementDialog}
    set widget(rev,.top26) {DataSummaryDialog}
    set widget(rev,.top26.fra28.fra46.ent48) {t_filename}
    set widget(rev,.top26.fra28.fra46.ent50) {t_filepath}
    set widget(rev,.top26.fra28.fra46.ent52) {t_filesize}
    set widget(rev,.top26.fra28.fra46.ent53) {t_records}
    set widget(rev,.top26.fra28.fra46.ent56) {t_dimensions}
    set widget(rev,.top26.fra28.fra46.lab17) {l_filename}
    set widget(rev,.top26.fra28.fra58.03) {DataFieldsCanvas}
    set widget(rev,.top27) {AboutDialog}
    set widget(rev,.top28) {BrushToolboxDialog}
    set widget(rev,.top28.fra43.fra17.01) {brActive_2}
    set widget(rev,.top28.fra43.fra17.02) {brEnable_2}
    set widget(rev,.top28.fra43.fra17.03) {brDisplay_2}
    set widget(rev,.top28.fra43.fra18.but19) {brActive_1}
    set widget(rev,.top28.fra43.fra18.but20) {brEnable_1}
    set widget(rev,.top28.fra43.fra18.but21) {brDisplay_1}
    set widget(rev,.top28.fra43.fra19.01) {brActive_3}
    set widget(rev,.top28.fra43.fra19.02) {brEnable_3}
    set widget(rev,.top28.fra43.fra19.03) {brDisplay_3}
    set widget(rev,.top28.fra43.fra20.01) {brActive_4}
    set widget(rev,.top28.fra43.fra20.02) {brEnable_4}
    set widget(rev,.top28.fra43.fra20.03) {brDisplay_4}
    set widget(rev,.top28.fra46.cpd17.01) {list_BrushOps}
    set widget(rev,.top28.fra46.lis17) {list_BrushOps}
    set widget(rev,.top29) {HtmlHelpDialog}
    set widget(rev,.top29.fra30.cpd33.03) {HtmlHelpText}
    set widget(rev,.top30) {DimStackBrushDialog}
    set widget(rev,.top30.01) {StackToolboxFrame}
    set widget(rev,.top31) {ParallelCoordBrushDialog}
    set widget(rev,.top31.fra33) {ParallelCoordBrushFrame}
    set widget(rev,.top32) {DimStackKeyDialog}
    set widget(rev,.top32.cpd34.03) {DimStackKeyText}
    set widget(rev,.top32.fra31.fra36.03) {DimStackKeyText}
    set widget(rev,.top33) {AuxillaryDisplayDialog}
    set widget(rev,.top33.fra34) {AuxillaryDisplayFrame}
    set widget(rev,.top33.men37) {m_auxillarydisplay}
    set widget(rev,.top34) {DataValuesDialog}
    set widget(rev,.top34.01.02.05) {DataValuesText}
    set widget(rev,.top39) {GlyphToolboxDialog}
    set widget(rev,.top39.fra40) {GlyphToolboxFrame}
    set widget(rev,.top40) {ClusterHierarchyDialog}
    set widget(rev,.top40.fra17.02) {histoFrame}
    set widget(rev,.top40.fra18) {histoFrame}
    set widget(rev,.top40.fra20.fra17.men18) {m_dependent_dims}
    set widget(rev,.top40.fra20.fra24.sca26) {DynamicMaskingScale}
    set widget(rev,.top40.fra20.fra27.che28) {bandsToggle}
    set widget(rev,.top40.fra20.fra27.sca29) {s_extentscaling}
    set widget(rev,.top40.fra20.fra30.sca36) {s_nonbrush}
    set widget(rev,.top40.fra20.fra30.sca38) {s_brushed}
    set widget(rev,.top40.fra40.fra18) {treemapFrame}
    set widget(rev,.top40.fra40.fra41) {StructBrushFrame}
    set widget(rev,.top40.fra40.fra42) {histoFrame}
    set widget(rev,.top40.fra40.fra46) {histoFrame}
    set widget(rev,.top40.fra41) {StructBrushFrame}
    set widget(rev,.top75.fra76) {hackFrame}
    set widget(s_brushed) {.top40.fra20.fra30.sca38}
    set widget(s_extentscaling) {.top40.fra20.fra27.sca29}
    set widget(s_nonbrush) {.top40.fra20.fra30.sca36}
    set widget(t_dimensions) {.top26.fra28.fra46.ent56}
    set widget(t_filename) {.top26.fra28.fra46.ent48}
    set widget(t_filepath) {.top26.fra28.fra46.ent50}
    set widget(t_filesize) {.top26.fra28.fra46.ent52}
    set widget(t_records) {.top26.fra28.fra46.ent53}
    set widget(treemapFrame) {.top40.fra40.fra18}

#################################
# USER DEFINED PROCEDURES
#
proc init {argc argv} {
# ------------------------------------
# Create iconic images used on buttons
# in the interface
#
#puts "--- Tcl Init (1)"
image create photo logo -file images/logo.gif
#image create photo icon_pc -file images/icon_pc.gif
#image create photo AFstep -file images/AFstep.gif
image create photo imgparcoord -file images/imgparcoord.gif
image create photo imgscat -file images/imgscat.gif
image create photo imgstack -file images/imgstack.gif
image create photo imgglyph -file images/imgglyph.gif
image create photo imghpc -file images/imghpc.gif

# ------------------------------------
# Define fonts for each platform
#

set SIZE 10
global tcl_platform
if { $tcl_platform(platform) == "unix" } {
	set SIZE 12
}

option add *font helvetica $SIZE

	font create menufont -family Helvetica -size $SIZE
	font create labelfont -family Helvetica -size $SIZE
	font create textfont -family Helvetica -size $SIZE
	font create fixedfont -family Courier -size $SIZE

global FontName FontSize Doublebuffer
set FontName Helvetica
set FontSize $SIZE
set Doublebuffer 1

# -------------------------------------
# brush selection box initialization
# 
foreach i { 1 2 3 4 } {
    global brType_$i
    set brType_$i step
}
}

init $argc $argv


proc {CanvasHorizScrollCmd} {action args} {
set status [ [W CanvasScrollHoriz] get]
set viewparm [ appGetCanvasViewParameters ]
# #puts "viewparm= $viewparm, status= $status, action= $action, args= $args"

set view_orgx [ lindex $viewparm 0 ]
set view_orgy [ lindex $viewparm 1 ]
set view_percentx [ lindex $viewparm 2 ]
set view_percenty [ lindex $viewparm 3 ]

# set startat [ lindex $status 0 ]
set startat [ lindex $viewparm 0 ]

if { $action == "moveto" } {
    set startat $args
}

if { $action == "scroll" } {
    set step [ lindex $args 0 ]
    set size [ lindex $args 1 ]
    
    if { $size == "units" } {
        set startat [ expr [ lindex $status 0 ] + [ expr $step * .01 ] ]
    }
    if { $size == "pages" } {
        set startat [ expr [ lindex $status 0 ] + [ expr $step * .1 ] ]
    }
}
if { $startat < 0 } {
    set startat 0
}
if { $startat > [ expr 1.0 - $view_percentx ] } {
    set startat [ expr 1.0 - $view_percentx ]
}
# #puts "startat = $startat"
[W CanvasScrollHoriz] set $startat [ expr $startat + $view_percentx ]

appSetViewScrollTo $startat $view_orgy
}

proc {CanvasVertScrollCmd} {action args} {
set status [ [W CanvasScrollVert] get]
set viewparm [ appGetCanvasViewParameters ]

set view_orgx [ lindex $viewparm 0 ]
set view_orgy [ lindex $viewparm 1 ]
set view_percentx [ lindex $viewparm 2 ]
set view_percenty [ lindex $viewparm 3 ]

# set startat [ lindex $status 1 ]
set startat [ lindex $viewparm 1 ]

if { $action == "moveto" } {
    set startat $args
}

if { $action == "scroll" } {
    set step [ lindex $args 0 ]
    set size [ lindex $args 1 ]
    
    if { $size == "units" } {
        set startat [ expr [ lindex $status 1 ] + [ expr $step * .01 ] ]
    }
    if { $size == "pages" } {
        set startat [ expr [ lindex $status 1 ] + [ expr $step * .1 ] ]
    }
}
if { $startat < 0 } {
    set startat 0
}
if { $startat > [ expr 1.0 - $view_percenty ] } {
    set startat [ expr 1.0 - $view_percenty ]
}
[W CanvasScrollVert] set $startat [ expr $startat + $view_percenty ]

appSetViewScrollTo $view_orgx $startat
}

proc {CanvasZoomCmd} {what} {
appSetCanvasZoom $what
CanvasHorizScrollCmd sync
CanvasVertScrollCmd sync
}

proc {Caption} {who what} {
global caption
	set caption($who) $what
	bind $who <Enter> { ShowCaption $caption(%W) }
	bind $who <Leave> { ClearCaption }
}

proc {ChangeFontSize} {sz} {
font configure menufont -size $sz
	font configure fixedfont -size $sz
}

proc {ClearBrushOperDialog} {} {
global brBrushOpType bt_values bt_average br_brush bt_not conjunc
set brBrushOpType ""
set bt_values 0
set bt_average 0

foreach i {1 2 3 4} { 
    set bt_not($i) 0
    set br_brush($i) ""
    set conjunc($i) ""
}
}

proc {ClearBrushOpsList} {} {
set list_num [[W list_BrushOps] size]
set idx 0
while {$idx < $list_num} {
    [W list_BrushOps] delete 0
    incr idx
}
}

proc {ClearCaption} {} {
#[W ConsoleCaption] delete 0 end
}

proc {ClickGlyphPDSelectButton} {direction} {
set w .top25.fra30.lis32
	set i [$w curselection]
	
	if { $i == "" } { return }

	switch -exact $direction {
	X { set dst .top25.fra28.fra17.ent18 }
	Y { set dst .top25.fra28.fra17.ent20 }
	}

	$dst config -state normal
	$dst delete 0 end
	$dst insert 0 [$w get $i]
	$dst config -state disable
}

proc {DynamicMaskingCmd} {what} {
appSetDynamicMaskingScale $what
#DynamicMaskingCmd sync
#DynamicMaskingCmd sync
}

proc {GlyphPlacementDialogCancel} {} {
destroy .top25
}

proc {GlyphPlacementDialogOK} {} {
global glyph_placement_space
	global glyph_placement_kind
	switch -exact $glyph_placement_kind {
		original {
			if { $glyph_placement_space } {
				appGlyphPlacementOriginal 1
			} else {
				appGlyphPlacementOriginal 0
			}
		}
		ordered {
			if { $glyph_placement_space } {
				set space 1
			} else {
				set space 0
			}
			global glyph_placement_increase
			set dst .top25.fra28.fra45.02	
			set name [$dst get]
			if { $name != ""} {
				if { $glyph_placement_increase } {
					appGlyphPlacementSort $name 1 $space			
				} else { 
					appGlyphPlacementSort $name 0 $space			
				}
			} 
		}
		data_driven {
			global glyph_placement_shift
			set dst .top25.fra28.fra17.ent18			
			set name1 [$dst get]
			set dst .top25.fra28.fra17.ent20			
			set name2 [$dst get]
			if { $name1 != "" && $name1 != ""} {
				if { $glyph_placement_shift } {
					appGlyphPlacementDataDriven $name1 $name2 1
				} else {
					appGlyphPlacementDataDriven $name1 $name2 0
				}
			} 
		}
		derived {
			set dst .top25.fra28.fra17.ent18			
			set name1 [$dst get]
			set dst .top25.fra28.fra17.ent20			
			set name2 [$dst get]
			if { $name1 != "" && $name1 != ""} {
					appGlyphPlacementDerived $name1 $name2 0
			} 
		}
	}
}

proc {InitMainMisc} {} {
#puts "--- InitMainMisc (3)";

[W ColorSelCanvas] create window 2 2 -window [W ColorSelCanvasFrame] -anchor nw
update
[W ColorSelCanvas] configure -scrollregion [ [W ColorSelCanvas] bbox 1 ]
SetupInterfaceColorDialog

[W CanvasScrollHoriz] set 0 1
[W CanvasScrollVert] set 0 1

Caption [W b_parcoord] "Parallel coordinates"
Caption [W b_glyphs] "Glyphs"
Caption [W b_scatter] "Scatterplots"
Caption [W b_dimstack] "Dimension Stacking"
Caption [W b_hierarchical] "Hierarchical Parallel coordinates"


# -------------------------------------
# Brush operations
# 
RebuiltBrushOpsList
}

proc {InitOpenGLCanvas} {parent name} {
set view $parent.$name
set wd [$parent cget -width]
set ht [$parent cget -height]
togl $view -rgba true -double true -depth false -ident $name -alpha false -width $wd -height $ht
global widget
set widget(togl.$name) $view
pack $view -side left -padx 2 -pady 2 -fill both -expand t
bind $view <KeyPress> { %W KeyPress %N }
bind $view <KeyRelease> { %W KeyRelease %N }
bind $view <ButtonPress> { %W ButtonPress %b %x %y }
# bind $view <Double-ButtonPress> { %W DoubleClick %b %x %y }
bind $view <ButtonRelease> { %W ButtonRelease %b %x %y }
bind $view <Motion> { %W Motion %x %y }
focus $view

global tcl_platform
if { $tcl_platform(platform) == "unix" } {
	tk_focusFollowsMouse
}
}

proc {ListSelectEnd} {w y} {
global glyph_placement_kind
	if {$glyph_placement_kind == "ordered"} {
		set dst .top25.fra28.fra45.02	
		$dst config -state normal
		$dst delete 0 end
		set i [$w curselection]
		$dst insert 0 [$w get $i]
		$dst config -state disable
	}
}

proc {LoadClusterFile} {okcfile cffile} {
if [file exists $cffile] {
#		set load_or_rebuild [ tk_dialog .cluster_query "Cluster file found" "A cluster file for this dataset is found. Do you wish to load it, or rebuild a new cluster tree?" "warning" 0 "Load it" "Rebuild" ]
#        if { $load_or_rebuild == 0 } { return; }
    }
return;
    Window show [W BirchDialog]
    raise [W BirchDialog]
	[W BirchDialogText] conf -state normal
	[W BirchDialogText] delete 0.0 end
	[W BirchDialogText] insert end [exec birch]
	[W BirchDialogText] conf -state disabled
    catch { grab [W BirchDialog]; tkwait window [W BirchDialog] }
    #puts "Run birch!.";
}

proc {MaskBrush} {} {
global mask_brush
	appSetMaskBrush $mask_brush
}

proc {MaskBrushedData} {} {
global mask_brushed_data
	appSetMaskBrushedData $mask_brushed_data
}

proc {MaskUnbrushedData} {} {
global mask_unbrushed_data
	appSetMaskUnbrushedData $mask_unbrushed_data
}

proc {OffGlyphPlacementDialogDataDrivenWidgets} {} {
set base .top25
	$base.fra28.fra17.but21 config -state disabled
	$base.fra28.fra17.but22 config -state disabled
	$base.fra28.fra17.che17 config -state disabled
	
	$base.fra28.fra17.ent18 config -relief flat
	$base.fra28.fra17.ent20 config -relief flat
	$base.fra28.fra17.ent18 config -state normal
	$base.fra28.fra17.ent20 config -state normal
	$base.fra28.fra17.ent18 delete 0 end
	$base.fra28.fra17.ent20 delete 0 end
	$base.fra28.fra17.ent18 config -state disabled
	$base.fra28.fra17.ent20 config -state disabled
}

proc {OffGlyphPlacementDialogListBox} {} {
set w .top25.fra30.lis32
	$w delete 0 end
	$w config -relief flat
}

proc {OffGlyphPlacementDialogOrderedWidgets} {} {
set base .top25
	$base.fra28.fra45.01 config -state disabled
	$base.fra28.fra45.02 config -state normal
	$base.fra28.fra45.02 delete 0 end
	$base.fra28.fra45.02 config -state disabled
	$base.fra28.fra45.02 config -relief flat
	
	$base.fra28.fra17.che18 config -state disabled
}

proc {PrintInterfaceColors} {} {
foreach i { background text data highlight overlap paint grid1 grid2 grid3 stat1 stat2 brush1 brush2 brush3 brush4 sbb} {
    set c [ appQueryInterfaceColor $i ]
    puts "SetInterfaceButtonColor $i $c"
}
}

proc {RaiseBrushDialog} {} {
Window show [W BrushDialog]
	raise [W BrushDialog]
}

proc {RaiseGlyphPlacementDialog} {} {
Window show [W GlyphPlacementDialog]
	raise [W GlyphPlacementDialog]
	global glyph_placement_kind
	set glyph_placement_kind original
	global glyph_placement_increase
	set glyph_placement_increase 1
	global glyph_placement_shift
	set glyph_placement_shift 0
	global glyph_placement_space
	set glyph_placement_space 0
	SetGlyphPlacementDialog $glyph_placement_kind
}

proc {RebuiltBrushOpsList} {} {
set index [[W list_BrushOps] curselection]
ClearBrushOpsList

set i 1
while {1} {
    set s [ appGetBrushOpString $i ]
    if { $s == "" } { break; }
    [W list_BrushOps] insert [expr $i - 1] $s
    incr i
}

if { $index != "" } {
    [W list_BrushOps] selection set $index
}
}

proc {RefreshGlyphPlacement} {} {
global glyph_placement_kind
	if { "$glyph_placement_kind" == "derived" } {
			SetGlyphPlacementDialogDataDrivenWidgets 
			SetGlyphPlacementDialogDerivedListBox
	}
}

proc {ResetDisplayModes} {} {
foreach i { b_parcoord b_glyphs b_scatter b_dimstack b_hierarchical } {
    [W $i] configure -relief raised -bg #e2e2de
}
}

proc {SelectDisplayMode} {what} {
[W b_$what] configure -relief sunken -bg #aaaaaa -activebackground #bbbbbb
appModeSelect $what
}

proc {SetActiveBrush} {which} {
foreach i { 1 2 3 4 } {
    [W brActive_$i] configure -relief raised
}
[W brActive_$which] configure -relief sunken
appSetActiveBrush [ expr $which - 1 ]
}

proc {SetBandsOnOff} {} {
global show_bands

if {$show_bands} {
    [W s_extentscaling] conf -state active
} else {
    [W s_extentscaling] conf -state disabled
}

appSetBandsOnOff $show_bands
}

proc {SetBrushDisplayState} {which} {
set b [W brDisplay_$which]
set state [ $b cget -relief ]
if { $state == "raised" } {
    appSetBrushDisplayState [ expr $which - 1 ] 1
    $b configure -relief sunken
} else {
    appSetBrushDisplayState [ expr $which - 1 ] 0
    $b configure -relief raised
}
}

proc {SetBrushEnableState} {which} {
set b [W brEnable_$which]
set state [ $b cget -relief ]
if { $state == "raised" } {
    appSetBrushEnableState [ expr $which - 1 ] 1
    $b configure -relief sunken
} else {
    appSetBrushEnableState [ expr $which - 1 ] 0
    $b configure -relief raised
}
}

proc {SetBrushedRadius} {what} {
appSetBrushedRadius $what
}

proc {SetClusterRadius} {what} {
appSetClusterRadius $what
}

proc {SetDependentDimension} {name num} {
[W m_dependent_dims] configure -text $name; 
appDependentDimensionHasChanged $num
}

proc {SetExtentScalingFactor} {what} {
appSetExtentScalingFactor [ expr 100-$what]
}

proc {SetGlyphPlacementDialog} {kind} {
set base .top25
	switch -exact $kind {
		original {
			OffGlyphPlacementDialogOrderedWidgets
			OffGlyphPlacementDialogDataDrivenWidgets 
			OffGlyphPlacementDialogListBox
			SetGlyphPlacementDialogOriginalWidgets 
		}
		ordered {
			OffGlyphPlacementDialogDataDrivenWidgets 
			SetGlyphPlacementDialogOrderedWidgets 
			SetGlyphPlacementDialogListBox
		}
		data_driven {
			OffGlyphPlacementDialogOrderedWidgets 
			SetGlyphPlacementDialogDataDrivenWidgets 
			SetGlyphPlacementDialogListBox
		}
		derived {
			OffGlyphPlacementDialogOrderedWidgets 
			SetGlyphPlacementDialogDataDrivenWidgets 
			SetGlyphPlacementDialogDerivedListBox
		}
	}
}

proc {SetGlyphPlacementDialogDataDrivenWidgets} {} {
set base .top25
	$base.fra28.fra17.ent18 config -relief groove
	$base.fra28.fra17.ent20 config -relief groove
	$base.fra28.fra17.but21 config -state normal
	$base.fra28.fra17.but22 config -state normal
	$base.fra28.fra17.che17 config -state normal
}

proc {SetGlyphPlacementDialogDerivedListBox} {} {
set w .top25.fra30.lis32
	$w delete 0 end
	set names [ appGetPrincipalNames ]
	set idx 0
	while {$idx < [llength $names]} {
		$w insert end [lindex $names $idx]
		incr idx
	}
	set names [ appGetDimensionNames ]
	set idx 0
	while {$idx < [llength $names]} {
		$w insert end [lindex $names $idx]
		incr idx
	}
	$w config -relief sunken
}

proc {SetGlyphPlacementDialogListBox} {} {
set w .top25.fra30.lis32
	$w delete 0 end
	set names [ appGetDimensionNames ]
	set idx 0
	while {$idx <= [llength $names]} {
		$w insert end [lindex $names $idx]
		incr idx
	}
	$w config -relief sunken
}

proc {SetGlyphPlacementDialogOrderedWidgets} {} {
set base .top25
	$base.fra28.fra45.01 config -state normal 
	$base.fra28.fra45.02 config -relief sunken
	$base.fra28.fra17.che18 config -state normal
}

proc {SetGlyphPlacementDialogOriginalWidgets} {} {
set base .top25
	$base.fra28.fra17.che18 config -state normal
}

proc {SetInterfaceButtonColor} {which what} {
if { $what == "" } {
    set what [ tk_chooseColor -title $which -initialcolor [[W b_$which] cget -bg]]
}
if { $what != ""} {
    appSetInterfaceColor $which $what
    SetupInterfaceColorDialog }
}

proc {SetupBrushStats} {} {
global widget  
	set row 1
	set i 0
	while { 1 } {
	    set info [ appGetFieldInfo [ expr $row - 1] ]
    	if { $info == "" } { break; }

		[W statsfield$row] delete all

		set onoff [lindex $info 1]
		if {$onoff == 1} {
			set minmax [ appDrawBrushStatsCanvas $i [W statsfield$row] ]
			[W minfield$row] configure -text [format "%.2f" [lindex $minmax 0]]
			[W maxfield$row] configure -text [format "%.2f" [lindex $minmax 1]]
			incr i
		}
		incr row
	}
	if { $i == 0 } {
		set par [W DataFieldsCanvas]
# WHY NEED TO DESTROY??
#		destroy $par.f
	}
}

proc {SetupClusterBrush} {} {
global show_bands
	global cluster_radius
	global brushed_radius
	global fade_factor
	global extent_scaling_fac
	set cb [ appGetClusterBrush ]
	set show_bands [lindex $cb 0 ]
	set cluster_radius [lindex $cb 1 ]
	set brushed_radius [lindex $cb 2 ]
	set fade_factor [lindex $cb 3 ]
	set extent_scaling_fac [lindex $cb 4 ]
}

proc {SetupDataSummary} {} {
set entrylist { filename filepath filesize records dimensions }

foreach i $entrylist {
    [W t_$i] conf -state normal
}

foreach i $entrylist  {
	[W t_$i] delete 0 end
}

set par [W DataFieldsCanvas]
destroy $par.f

set s [appGetDatasetSummary]

if { $s == "" } {
	return;
}

set j 0
foreach i $entrylist  {
    [W t_$i] insert 0 [lindex $s $j]
    set j [ expr $j + 1 ]
}

foreach i $entrylist  {
    [W t_$i] conf -state disabled
}

frame $par.f -bg red -width 5000 -height 5000
pack $par.f -expand t -fill both

$par create window 2 2 -window $par.f -anchor nw

label $par.f.h1 -text "Fieldname" -borderwidth 1 -relief raised -pady 3 -padx 2 -background gray -font menufont
grid $par.f.h1 -column 0 -row 0 -sticky nsew
label $par.f.h2 -text "Enabled" -borderwidth 1 -relief raised -pady 3 -padx 2 -background gray -font menufont
grid $par.f.h2 -column 1 -row 0 -sticky nsew
#label $par.f.h3 -text "Min" -borderwidth 1 -relief raised -pady 3 -padx 2 -background gray
#grid $par.f.h3 -column 2 -row 0 -sticky nsew
#label $par.f.h4 -text "Max" -borderwidth 1 -relief raised -pady 3 -padx 2 -background gray
#grid $par.f.h4 -column 3 -row 0 -sticky nsew
label $par.f.h5 -text "Brush coverage" -borderwidth 1 -relief raised -pady 3 -padx 50 -background gray -width 10 -font menufont
grid $par.f.h5 -column 2 -row 0 -sticky nsew -columnspan 3
label $par.f.h6 -text "Reorder" -borderwidth 1 -relief raised -pady 3 -padx 2 -background gray -font menufont
grid $par.f.h6 -column 5 -row 0 -sticky nsew -columnspan 2

global varfield
global widget
set row 1
while { 1 } {
	set info [ appGetFieldInfo [ expr $row - 1] ]
	if { $info == "" } { break; }

	label $par.f.f1$row -text [lindex $info 0] -borderwidth 1 -relief raised -pady 3 -padx 8 -background #e2e2de -anchor w -font menufont
	grid $par.f.f1$row -column 0 -row $row -sticky nsew
	set varfield($row) [lindex $info 1]

	checkbutton $par.f.f2$row -variable varfield($row) -borderwidth 1 -relief raised -pady 3 -padx 8 -background #e2e2de -anchor center  -command [list togglefield $row ] -font menufont
	grid $par.f.f2$row -column 1 -row $row -sticky nsew

	label $par.f.f3$row -text [format "%.02f" [lindex $info 2]] -borderwidth 1 -relief raised -pady 3 -padx 8 -background #e2e2de -anchor w -font menufont
	grid $par.f.f3$row -column 2 -row $row -sticky nsew
	set widget(minfield$row) $par.f.f3$row

	label $par.f.f4$row -text [format "%.02f" [lindex $info 3]] -borderwidth 1 -relief raised -pady 3 -padx 8 -background #e2e2de -anchor w -font menufont
	grid $par.f.f4$row -column 4 -row $row -sticky nsew
	set widget(maxfield$row) $par.f.f4$row

	canvas $par.f.f5$row -relief raised -background #e2e2de -borderwidth 1 -height 25 -width 250
	grid $par.f.f5$row -column 3 -row $row -sticky nsew
	set widget(statsfield$row) $par.f.f5$row

	set temp [ expr $row - 1]
	button $par.f.f6$row -command [list appReorderDimension $temp 1] -text "<-"  -relief raised -borderwidth 1 -pady 3 -padx 8 -background #e2e2de -anchor center  -font menufont
	grid $par.f.f6$row -column 5 -row $row -sticky nsew

	button $par.f.f7$row -command [list appReorderDimension $temp 0] -text "->"  -relief raised -borderwidth 1 -pady 3 -padx 8 -background #e2e2de -anchor center  -font menufont
	grid $par.f.f7$row -column 6 -row $row -sticky nsew

	incr row
}

SetupBrushStats;

update
$par configure -scrollregion [ grid bbox $par.f ]
}

proc {SetupDependentDimensionsMenu} {} {
#Delete previous entries
[W m_dependent_dims].m delete 0 end
set dim 1
while {1} {
    set dim_name [ appGetDimensionName [expr $dim - 1] ]
    if {$dim_name == ""} break;
    if {$dim==1} { [W m_dependent_dims] configure -text $dim_name }
    [W m_dependent_dims].m add command -command [list SetDependentDimension $dim_name $dim] -label $dim_name -font menufont
    
    incr dim
}
}

proc {SetupDimStackKeyDialog} {} {
[W DimStackKeyText] conf -state normal
[W DimStackKeyText] delete 0.0 end
[W DimStackKeyText] insert end [ appQueryDimStackKey ]
[W DimStackKeyText] conf -state disabled
}

proc {SetupGlyphKeyDialog} {} {
[W GlyphKeyText] conf -state normal
[W GlyphKeyText] delete 0.0 end
[W GlyphKeyText] insert end [ appQueryGlyphKey ]
[W GlyphKeyText] conf -state disabled
}

proc {SetupGlyphPlacement} {} {
global glyph_placement_kind
	set glyph_placement_kind original
	SetGlyphPlacementDialog $glyph_placement_kind
}

proc {SetupHypertextHelp} {} {
[W HtmlHelpText] configure -state normal
uplevel #0 source htmlwidget/html_library.tcl
	uplevel #0 source htmlwidget/utils.tcl

	upvar #0 Url HtmlWidget
	global Url UrlHome HtmlWidget

	set UrlHome [pwd]/htmlhelp/help.html
	set Url $UrlHome
	set HtmlWidget [W HtmlHelpText]
	HMinit_win $HtmlWidget
	HMset_state $HtmlWidget -size 1
#	HMset_indent $HtmlWidget 2
	render $UrlHome
	
[W HtmlHelpText] configure -state disabled
}

proc {SetupInterfaceColorDialog} {} {
foreach i { background text data highlight overlap paint grid1 grid2 grid3 stat1 stat2 brush1 brush2 brush3 brush4 sbb } {
    set c [ appQueryInterfaceColor $i ]
    [W b_$i] configure -bg $c -activebackground $c 
}
}

proc {ShowCaption} {what} {
#[W ConsoleCaption] insert 0 $what
[W ConsoleCaption] conf -text $what
}

proc {ShowHelpFile} {which} {
Window show [W HelpDialog]
raise [W HelpDialog]
set f [open $which r]
[W HelpText] conf -state normal
[W HelpText] delete 0.0 end
[W HelpText] insert end [read $f]
[W HelpText] conf -state disabled
close $f
}

proc {UpdateClusterRadiusSliders} {outer inner} {
global cluster_radius brushed_radius
set cluster_radius $outer
set brushed_radius $inner
}

proc {W} {what} {
global widget
set ex [ winfo exists $widget($what) ]
if { $ex == 0 } {
	Window show $widget($what)
}
set ex [ winfo exists $widget($what) ]
if { $ex == 0 } {
	puts "Tcl error: Invalid widget request: $what. Program terminated."
	exit
}
return $widget($what)
}

proc {toggleBrushes} {which val} {
#THIS DOESN'T WORK
#global br_brush
#puts "curr=$br_brush($which) new = $val"
#if { $br_brush($which) == "$val" } {
#    set br_brush($which) -1
#}
}

proc {togglefield} {which} {
global varfield
	set state $varfield($which)
	appSetFieldOnOff [ expr $which - 1] $state
	SetupBrushStats
}

proc {main} {argc argv} {
#puts "--- Tcl tkXmdv main (2)"

InitOpenGLCanvas [W StructBrushFrame] structBrushCanvas
InitOpenGLCanvas [W histoFrame] histoCanvas
InitOpenGLCanvas [W treemapFrame] treemapCanvas
InitOpenGLCanvas [W ParallelCoordBrushFrame] minimapCanvas
InitOpenGLCanvas [W CanvasFrame] mainCanvas
InitOpenGLCanvas [W GlyphToolboxFrame] glyphToolboxCanvas
InitOpenGLCanvas [W StackToolboxFrame] stackToolboxCanvas
InitOpenGLCanvas [W AuxillaryDisplayFrame] auxillaryDisplayCanvas

Window hide [W HelpDialog] 
Window hide [W GlyphPlacementDialog] 
Window hide [W AboutDialog] 
Window hide [W InterfaceColorDialog]
Window hide [W DataSummaryDialog]
Window hide [W GlyphKeyDialog]
Window hide [W DimStackKeyDialog]
Window hide [W BirchDialog]
Window hide [W ClusterHierarchyDialog]
Window hide [W BrushToolboxDialog]
Window hide [W BrushOperationDialog]
Window hide [W GlyphToolboxDialog]
Window hide [W DimStackBrushDialog]
Window hide [W HtmlHelpDialog]
Window hide [W ParallelCoordBrushDialog]
Window hide [W AuxillaryDisplayDialog]
Window hide [W DataValuesDialog]
Window hide [W BrushDialog]
Window hide .

# Setup default startup state
#
appModeSelect "parcoord"
appLoadOkcFile "data/aaup.okc"
SetupDataSummary

appMainInit
SetupHypertextHelp

puts "--- Tcl startup complete (*)."
}

proc {Window} {args} {
global vTcl
    set cmd [lindex $args 0]
    set name [lindex $args 1]
    set newname [lindex $args 2]
    set rest [lrange $args 3 end]
    if {$name == "" || $cmd == ""} {return}
    if {$newname == ""} {
        set newname $name
    }
    set exists [winfo exists $newname]
    switch $cmd {
        show {
            if {$exists == "1" && $name != "."} {wm deiconify $name; return}
            if {[info procs vTclWindow(pre)$name] != ""} {
                eval "vTclWindow(pre)$name $newname $rest"
            }
            if {[info procs vTclWindow$name] != ""} {
                eval "vTclWindow$name $newname $rest"
            }
            if {[info procs vTclWindow(post)$name] != ""} {
                eval "vTclWindow(post)$name $newname $rest"
            }
        }
        hide    { if $exists {wm withdraw $newname; return} }
        iconify { if $exists {wm iconify $newname; return} }
        destroy { if $exists {destroy $newname; return} }
    }
}

#################################
# VTCL GENERATED GUI PROCEDURES
#

proc vTclWindow. {base} {
    if {$base == ""} {
        set base .
    }
    ###################
    # CREATING WIDGETS
    ###################
    wm focusmodel $base passive
    wm geometry $base 132x1+32+736
    wm maxsize $base 1265 994
    wm minsize $base 132 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "vt.tcl"
    ###################
    # SETTING GEOMETRY
    ###################
}

proc vTclWindow.top17 {base} {
    if {$base == ""} {
        set base .top17
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -menu .top17.m17 
    wm focusmodel $base passive
    wm geometry $base 836x630+38+50
    wm maxsize $base 1265 994
    wm minsize $base 132 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "System 1"
    frame $base.fra20 \
        -background #aaaaaa -borderwidth 2 -height 4 -relief groove 
    frame $base.fra20.fra18 \
        -borderwidth 2 -height 27 -relief groove -width 125 
    label $base.fra20.fra18.lab17 \
        -anchor w -background #eaeaea -borderwidth 1 -font menufont \
        -justify left -relief sunken 
    frame $base.fra20.fra41 \
        -borderwidth 2 -height 309 -relief groove -width 17 
    button $base.fra20.fra41.but42 \
        -activebackground #bbbbbb -background #aaaaaa \
        -command {ResetDisplayModes
SelectDisplayMode "parcoord"} \
        -font menufont -image imgparcoord -padx 9 -pady 3 -relief sunken \
        -text {Parallel Coordinates} 
    button $base.fra20.fra41.but44 \
        -activebackground #bbbbbb -background #e2e2de \
        -command {ResetDisplayModes
SelectDisplayMode "scatter"} \
        -font menufont -highlightcolor black -image imgscat -padx 9 -pady 10 \
        -text scatter 
    button $base.fra20.fra41.but18 \
        -activebackground #bbbbbb -background #e2e2de \
        -command RaiseBrushDialog -font menufont -highlightcolor black \
        -image imghpc -padx 9 -pady 10 -text hier_pc 
    scale $base.fra20.fra41.sca19 \
        -activebackground #d9d9d9 -command CanvasZoomCmd -font menufont \
        -from 1.0 -highlightthickness 0 
    label $base.fra20.fra41.lab18 \
        -background gray -borderwidth 1 -font menufont -pady 3 -relief raised \
        -text Zoom 
    button $base.fra20.fra41.but19 \
        -command appDeMagnify -font menufont -padx 3 -pady 3 -text - 
    button $base.fra20.fra41.but20 \
        -command appMagnify -font menufont -padx 0 -pady 3 -text + 
    button $base.fra20.fra41.but43 \
        -activebackground #bbbbbb -background #e2e2de \
        -command {ResetDisplayModes
SelectDisplayMode "glyphs"} \
        -font menufont -highlightcolor black -image imgglyph -padx 9 -pady 10 \
        -text glyphs 
    button $base.fra20.fra41.but45 \
        -background #e2e2de \
        -command {ResetDisplayModes
SelectDisplayMode "dimstack"} \
        -font menufont -highlightcolor black -image imgstack -padx 9 -pady 10 \
        -text stack 
    scrollbar $base.fra20.scr24 \
        -background gray -command CanvasHorizScrollCmd -orient horiz \
        -troughcolor gray 
    frame $base.fra20.fra19 \
        -borderwidth 2 -height 590 -relief groove -width 742 
    scrollbar $base.fra20.scr17 \
        -activebackground gray -background gray -command CanvasVertScrollCmd \
        -orient vert -troughcolor gray 
    menu $base.m17 \
        -activeborderwidth 1 -borderwidth 1 -cursor {} -font helvetica \
        -tearoff 0 
    $base.m17 add command \
        -command exit -label {Quit System 1} 
    $base.m17 add command \
        \
        -command {set filename [ tk_getSaveFile -defaultextension ".ppm" \
										-initialdir "c:/yangjing/experiment1/flat_images" \
										-filetypes { { {ppm files} {.ppm} } } ]
appSaveMainCanvasImage $filename} \
        -label {Save Image} 
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.fra20 \
        -in .top17 -anchor w -expand 1 -fill both -side left 
    pack $base.fra20.fra18 \
        -in .top17.fra20 -anchor center -expand 0 -fill x -side bottom 
    pack $base.fra20.fra18.lab17 \
        -in .top17.fra20.fra18 -anchor center -expand 1 -fill x -padx 1 \
        -pady 1 -side top 
    pack $base.fra20.fra41 \
        -in .top17.fra20 -anchor center -expand 0 -fill y -side right 
#    pack $base.fra20.fra41.but42 \
#        -in .top17.fra20.fra41 -anchor center -expand 0 -fill none -side top 
#    pack $base.fra20.fra41.but44 \
#        -in .top17.fra20.fra41 -anchor center -expand 0 -fill x -side top 
    pack $base.fra20.fra41.but18 \
        -in .top17.fra20.fra41 -anchor center -expand 0 -fill x -side top 
    pack $base.fra20.fra41.sca19 \
        -in .top17.fra20.fra41 -anchor center -expand 0 -fill both \
        -side bottom 
    pack $base.fra20.fra41.lab18 \
        -in .top17.fra20.fra41 -anchor center -expand 0 -fill x -side bottom 
    pack $base.fra20.scr24 \
        -in .top17.fra20 -anchor center -expand 0 -fill x -side bottom 
    pack $base.fra20.fra19 \
        -in .top17.fra20 -anchor e -expand 1 -fill both -side left 
    pack $base.fra20.scr17 \
        -in .top17.fra20 -anchor ne -expand 0 -fill y -side left 
}

proc vTclWindow.top18 {base} {
    if {$base == ""} {
        set base .top18
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -menu .top18.m35 
    wm focusmodel $base passive
    wm geometry $base 307x1013+137+61
    wm maxsize $base 1265 994
    wm minsize $base 132 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "Interface Colors"
    frame $base.fra17 \
        -borderwidth 1 -height 75 -relief sunken -width 125 
    label $base.fra17.lab18 \
        -background gray -font menufont -relief raised \
        -text {Interface Color Scheme} 
    frame $base.fra17.fra19 \
        -borderwidth 1 -relief raised -width 2 
    scrollbar $base.fra17.fra19.01 \
        -activebackground gray -background gray -borderwidth 1 \
        -command {.top18.fra17.fra19.03 xview} -orient horiz \
        -troughcolor gray -width 10 
    scrollbar $base.fra17.fra19.02 \
        -background gray -borderwidth 1 \
        -command {.top18.fra17.fra19.03 yview} -orient vert -troughcolor gray \
        -width 10 
    canvas $base.fra17.fra19.03 \
        -borderwidth 2 -height 50 -relief ridge -scrollregion {0 0 200 200} \
        -width 50 -xscrollcommand {.top18.fra17.fra19.01 set} \
        -yscrollcommand {.top18.fra17.fra19.02 set} 
    frame $base.fra17.fra19.03.04 \
        -background #aaaaaa -borderwidth 2 -height 24 -relief groove \
        -width 100 
    button $base.fra17.fra19.03.04.05 \
        -command {SetInterfaceButtonColor "text" ""; appRefreshAllCanvas} \
        -font menufont -padx 9 -pady 3 
    button $base.fra17.fra19.03.04.06 \
        -command {SetInterfaceButtonColor "stat2" ""; appRefreshAllCanvas} \
        -font menufont -padx 9 -pady 3 
    button $base.fra17.fra19.03.04.07 \
        -command {SetInterfaceButtonColor "stat1" ""; appRefreshAllCanvas} \
        -font menufont -padx 9 -pady 3 
    button $base.fra17.fra19.03.04.08 \
        \
        -command {SetInterfaceButtonColor "background" ""; appRefreshAllCanvas} \
        -font menufont -padx 9 -pady 3 
    button $base.fra17.fra19.03.04.09 \
        -command {SetInterfaceButtonColor "grid3" ""; appRefreshAllCanvas} \
        -font menufont -padx 9 -pady 3 
    button $base.fra17.fra19.03.04.010 \
        -command {SetInterfaceButtonColor "grid2" ""; appRefreshAllCanvas} \
        -font menufont -padx 9 -pady 3 
    button $base.fra17.fra19.03.04.011 \
        -command {SetInterfaceButtonColor "grid1" ""; appRefreshAllCanvas} \
        -font menufont -padx 9 -pady 3 
    button $base.fra17.fra19.03.04.012 \
        -command {SetInterfaceButtonColor "data" ""; appRefreshAllCanvas} \
        -font menufont -padx 9 -pady 3 
    button $base.fra17.fra19.03.04.013 \
        \
        -command {SetInterfaceButtonColor "highlight" ""; appRefreshAllCanvas} \
        -font menufont -padx 9 -pady 3 
    button $base.fra17.fra19.03.04.014 \
        -command {SetInterfaceButtonColor "overlap" ""; appRefreshAllCanvas} \
        -font menufont -padx 9 -pady 3 
    button $base.fra17.fra19.03.04.015 \
        -command {SetInterfaceButtonColor "paint" ""; appRefreshAllCanvas} \
        -font menufont -padx 9 -pady 3 
    label $base.fra17.fra19.03.04.016 \
        -background gray -borderwidth 1 -font menufont -relief raised \
        -text Text 
    label $base.fra17.fra19.03.04.017 \
        -background gray -borderwidth 1 -font menufont -relief raised \
        -text Background 
    label $base.fra17.fra19.03.04.018 \
        -background gray -borderwidth 1 -font menufont -relief raised \
        -text Stat-1 
    label $base.fra17.fra19.03.04.019 \
        -background gray -borderwidth 1 -font menufont -relief raised \
        -text Stat-2 
    label $base.fra17.fra19.03.04.020 \
        -background gray -borderwidth 1 -font menufont -relief raised \
        -text Grid-3 
    label $base.fra17.fra19.03.04.021 \
        -background gray -borderwidth 1 -font menufont -relief raised \
        -text Grid-2 
    label $base.fra17.fra19.03.04.022 \
        -background gray -borderwidth 1 -font menufont -relief raised \
        -text Grid-1 
    label $base.fra17.fra19.03.04.023 \
        -background gray -borderwidth 1 -font menufont -relief raised \
        -text Data 
    label $base.fra17.fra19.03.04.024 \
        -background gray -borderwidth 1 -font menufont -relief raised \
        -text Highlight 
    label $base.fra17.fra19.03.04.025 \
        -background gray -borderwidth 1 -font menufont -relief raised \
        -text Overlap 
    label $base.fra17.fra19.03.04.026 \
        -background gray -borderwidth 1 -font menufont -relief raised \
        -text Paint 
    button $base.fra17.fra19.03.04.027 \
        -command {SetInterfaceButtonColor "brush1" ""; appRefreshAllCanvas} \
        -font menufont -padx 9 -pady 3 
    button $base.fra17.fra19.03.04.028 \
        -command {SetInterfaceButtonColor "brush2" ""; appRefreshAllCanvas} \
        -font menufont -padx 9 -pady 3 
    button $base.fra17.fra19.03.04.029 \
        -command {SetInterfaceButtonColor "brush3" ""; appRefreshAllCanvas} \
        -font menufont -padx 9 -pady 3 
    button $base.fra17.fra19.03.04.030 \
        -command {SetInterfaceButtonColor "brush4" ""; appRefreshAllCanvas} \
        -font menufont -padx 9 -pady 3 
    label $base.fra17.fra19.03.04.031 \
        -background gray -borderwidth 1 -font menufont -relief raised \
        -text Brush-1 
    label $base.fra17.fra19.03.04.032 \
        -background gray -borderwidth 1 -font menufont -relief raised \
        -text Brush-4 
    label $base.fra17.fra19.03.04.033 \
        -background gray -borderwidth 1 -font menufont -relief raised \
        -text Brush-3 
    label $base.fra17.fra19.03.04.034 \
        -background gray -borderwidth 1 -font menufont -relief raised \
        -text Brush-2 
    label $base.fra17.fra19.03.04.lab17 \
        -background gray -borderwidth 1 -font menufont -relief raised \
        -text {Structure-Based Brush} 
    button $base.fra17.fra19.03.04.but18 \
        -command {SetInterfaceButtonColor "sbb" ""; appRefreshAllCanvas} \
        -font menufont -padx 9 -pady 3 
    frame $base.fra24 \
        -borderwidth 1 -height 75 -relief sunken -width 125 
    menubutton $base.fra24.men25 \
        -font menufont -indicatoron 1 -menu .top18.fra24.men25.01 -padx 4 \
        -pady 3 -relief raised -text {Preset Themes} 
    menu $base.fra24.men25.01 \
        -activeborderwidth 1 -borderwidth 1 -cursor {} -font menufont \
        -tearoff 0 
    $base.fra24.men25.01 add command \
        \
        -command {SetInterfaceButtonColor background #ffffff
SetInterfaceButtonColor text #000000
SetInterfaceButtonColor data #61f369
SetInterfaceButtonColor highlight #f20000
SetInterfaceButtonColor overlap #000000
SetInterfaceButtonColor paint #980098
SetInterfaceButtonColor grid1 #ff0f0f
SetInterfaceButtonColor grid2 #afafaf
SetInterfaceButtonColor grid3 #eaeaea
SetInterfaceButtonColor stat1 #0000ea
SetInterfaceButtonColor stat2 #c30000
SetInterfaceButtonColor brush1 #afafea
SetInterfaceButtonColor brush2 #afafaf
SetInterfaceButtonColor brush3 #afaf75
SetInterfaceButtonColor brush4  #dfceac
SetInterfaceButtonColor sbb #f6a430
appRefreshAllCanvas} \
        -label Original 
    $base.fra24.men25.01 add command \
        \
        -command {SetInterfaceButtonColor background #000000
SetInterfaceButtonColor text #fefe00
SetInterfaceButtonColor data #98f298
SetInterfaceButtonColor highlight #f20000
SetInterfaceButtonColor overlap #000000
SetInterfaceButtonColor paint #980098
SetInterfaceButtonColor grid1 #fe5c5e
SetInterfaceButtonColor grid2 #afafaf
SetInterfaceButtonColor grid3 #eaeaea
SetInterfaceButtonColor stat1 #0000ea
SetInterfaceButtonColor stat2 #c30000
SetInterfaceButtonColor brush1 #afafea
SetInterfaceButtonColor brush2 #afafaf
SetInterfaceButtonColor brush3 #afaf75
SetInterfaceButtonColor brush4 #dfdb9a
SetInterfaceButtonColor sbb  #f6a430
appRefreshAllCanvas} \
        -label Nocturnal 
    $base.fra24.men25.01 add command \
        \
        -command {SetInterfaceButtonColor background #ffffff
SetInterfaceButtonColor text #000000
SetInterfaceButtonColor data #000000
SetInterfaceButtonColor highlight #fe0000
SetInterfaceButtonColor overlap #000000
SetInterfaceButtonColor paint #980098
SetInterfaceButtonColor grid1 #000000
SetInterfaceButtonColor grid2 #afafaf
SetInterfaceButtonColor grid3 #eaeaea
SetInterfaceButtonColor stat1 #fefefe
SetInterfaceButtonColor stat2 #fefefe
SetInterfaceButtonColor brush1 #dadada
SetInterfaceButtonColor brush2 #afafaf
SetInterfaceButtonColor brush3 #afaf75
SetInterfaceButtonColor brush4 #d8d69e
SetInterfaceButtonColor sbb  #f6a430
appRefreshAllCanvas} \
        -label Grays 
    $base.fra24.men25.01 add command \
        \
        -command {SetInterfaceButtonColor background #000096
SetInterfaceButtonColor text #fffefe
SetInterfaceButtonColor data #eaeca0
SetInterfaceButtonColor highlight #28d320
SetInterfaceButtonColor overlap #000000
SetInterfaceButtonColor paint #980098
SetInterfaceButtonColor grid1 #fffefe
SetInterfaceButtonColor grid2 #afafaf
SetInterfaceButtonColor grid3 #eaeaea
SetInterfaceButtonColor stat1 #0000ea
SetInterfaceButtonColor stat2 #c30000
SetInterfaceButtonColor brush1 #8e3014
SetInterfaceButtonColor brush2 #afafaf
SetInterfaceButtonColor brush3 #afaf75
SetInterfaceButtonColor brush4 #d8d69e
SetInterfaceButtonColor sbb  #f6a430
appRefreshAllCanvas} \
        -label {Midnight Blue} 
    $base.fra24.men25.01 add command \
        \
        -command {SetInterfaceButtonColor background #48b000
SetInterfaceButtonColor text #fefbfe
SetInterfaceButtonColor data #5155fe
SetInterfaceButtonColor highlight #fffa66
SetInterfaceButtonColor overlap #000000
SetInterfaceButtonColor paint #980098
SetInterfaceButtonColor grid1 #000000
SetInterfaceButtonColor grid2 #afafaf
SetInterfaceButtonColor grid3 #eaeaea
SetInterfaceButtonColor stat1 #fefefe
SetInterfaceButtonColor stat2 #fefefe
SetInterfaceButtonColor brush1 #806260
SetInterfaceButtonColor brush2 #afafaf
SetInterfaceButtonColor brush3 #afaf75
SetInterfaceButtonColor brush4 #d8d69e
SetInterfaceButtonColor sbb  #f6a430
appRefreshAllCanvas} \
        -label {Sea green} 
    $base.fra24.men25.01 add separator
    $base.fra24.men25.01 add command \
        \
        -command {foreach i { background text data highlight overlap paint grid1 grid2 grid3 stat1 stat2 brush1 brush2 brush3 brush4 sbb} {
    set c [ appQueryInterfaceColor $i ]
    scan $c "#%2x%2x%2x" r g b
    set r [ expr 255 - $r ]
    set g [ expr 255 - $g ]
    set b [ expr 255 - $b ]
    set c [ format "#%02x%02x%02x" $r $g $b ]
    SetInterfaceButtonColor $i $c
}
appRefreshAllCanvas} \
        -label {Invert colors} 
    frame $base.fra22 \
        -borderwidth 1 -height 75 -relief sunken -width 125 
    button $base.fra22.but23 \
        -command {Window hide [W InterfaceColorDialog]} -font menufont \
        -padx 9 -pady 3 -text OK 
    menu $base.m35 \
        -activeborderwidth 1 -borderwidth 1 -cursor {} -font menufont 
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.fra17 \
        -in .top18 -anchor center -expand 1 -fill both -padx 8 -pady 8 \
        -side top 
    pack $base.fra17.lab18 \
        -in .top18.fra17 -anchor center -expand 0 -fill x -ipadx 4 -ipady 4 \
        -padx 4 -pady 4 -side top 
    pack $base.fra17.fra19 \
        -in .top18.fra17 -anchor center -expand 1 -fill both -padx 4 -pady 2 \
        -side top 
    grid columnconf $base.fra17.fra19 0 -weight 1
    grid rowconf $base.fra17.fra19 0 -weight 1
    grid $base.fra17.fra19.01 \
        -in .top18.fra17.fra19 -column 0 -row 1 -columnspan 1 -rowspan 1 \
        -sticky ew 
    grid $base.fra17.fra19.02 \
        -in .top18.fra17.fra19 -column 1 -row 0 -columnspan 1 -rowspan 1 \
        -sticky ns 
    grid $base.fra17.fra19.03 \
        -in .top18.fra17.fra19 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    pack $base.fra17.fra19.03.04 \
        -in .top18.fra17.fra19.03 -anchor center -expand 0 -fill none \
        -side top 
    grid columnconf $base.fra17.fra19.03.04 0 -weight 1
    grid columnconf $base.fra17.fra19.03.04 1 -weight 3
    grid $base.fra17.fra19.03.04.05 \
        -in .top18.fra17.fra19.03.04 -column 1 -row 0 -columnspan 1 \
        -rowspan 1 -ipadx 30 -sticky nesw 
    grid $base.fra17.fra19.03.04.06 \
        -in .top18.fra17.fra19.03.04 -column 1 -row 11 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra17.fra19.03.04.07 \
        -in .top18.fra17.fra19.03.04 -column 1 -row 10 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra17.fra19.03.04.08 \
        -in .top18.fra17.fra19.03.04 -column 1 -row 1 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra17.fra19.03.04.09 \
        -in .top18.fra17.fra19.03.04 -column 1 -row 14 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra17.fra19.03.04.010 \
        -in .top18.fra17.fra19.03.04 -column 1 -row 13 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra17.fra19.03.04.011 \
        -in .top18.fra17.fra19.03.04 -column 1 -row 12 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra17.fra19.03.04.012 \
        -in .top18.fra17.fra19.03.04 -column 1 -row 2 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra17.fra19.03.04.013 \
        -in .top18.fra17.fra19.03.04 -column 1 -row 3 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra17.fra19.03.04.014 \
        -in .top18.fra17.fra19.03.04 -column 1 -row 4 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra17.fra19.03.04.015 \
        -in .top18.fra17.fra19.03.04 -column 1 -row 5 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra17.fra19.03.04.016 \
        -in .top18.fra17.fra19.03.04 -column 0 -row 0 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra17.fra19.03.04.017 \
        -in .top18.fra17.fra19.03.04 -column 0 -row 1 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra17.fra19.03.04.018 \
        -in .top18.fra17.fra19.03.04 -column 0 -row 10 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra17.fra19.03.04.019 \
        -in .top18.fra17.fra19.03.04 -column 0 -row 11 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra17.fra19.03.04.020 \
        -in .top18.fra17.fra19.03.04 -column 0 -row 14 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra17.fra19.03.04.021 \
        -in .top18.fra17.fra19.03.04 -column 0 -row 13 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra17.fra19.03.04.022 \
        -in .top18.fra17.fra19.03.04 -column 0 -row 12 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra17.fra19.03.04.023 \
        -in .top18.fra17.fra19.03.04 -column 0 -row 2 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra17.fra19.03.04.024 \
        -in .top18.fra17.fra19.03.04 -column 0 -row 3 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra17.fra19.03.04.025 \
        -in .top18.fra17.fra19.03.04 -column 0 -row 4 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra17.fra19.03.04.026 \
        -in .top18.fra17.fra19.03.04 -column 0 -row 5 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra17.fra19.03.04.027 \
        -in .top18.fra17.fra19.03.04 -column 1 -row 6 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra17.fra19.03.04.028 \
        -in .top18.fra17.fra19.03.04 -column 1 -row 7 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra17.fra19.03.04.029 \
        -in .top18.fra17.fra19.03.04 -column 1 -row 8 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra17.fra19.03.04.030 \
        -in .top18.fra17.fra19.03.04 -column 1 -row 9 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra17.fra19.03.04.031 \
        -in .top18.fra17.fra19.03.04 -column 0 -row 6 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra17.fra19.03.04.032 \
        -in .top18.fra17.fra19.03.04 -column 0 -row 9 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra17.fra19.03.04.033 \
        -in .top18.fra17.fra19.03.04 -column 0 -row 8 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra17.fra19.03.04.034 \
        -in .top18.fra17.fra19.03.04 -column 0 -row 7 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra17.fra19.03.04.lab17 \
        -in .top18.fra17.fra19.03.04 -column 0 -row 15 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra17.fra19.03.04.but18 \
        -in .top18.fra17.fra19.03.04 -column 1 -row 15 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    pack $base.fra24 \
        -in .top18 -anchor center -expand 0 -fill x -padx 8 -pady 4 -side top 
    pack $base.fra24.men25 \
        -in .top18.fra24 -anchor center -expand 0 -fill x -padx 4 -pady 4 \
        -side top 
    pack $base.fra22 \
        -in .top18 -anchor center -expand 0 -fill x -padx 8 -pady 4 -side top 
    pack $base.fra22.but23 \
        -in .top18.fra22 -anchor center -expand 0 -fill x -padx 4 -pady 4 \
        -side top 
}

proc vTclWindow.top19 {base} {
    if {$base == ""} {
        set base .top19
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 249x130+772+269
    wm maxsize $base 1028 748
    wm minsize $base 132 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "Brush Dialog"
    frame $base.fra22 \
        -borderwidth 2 -height 75 -relief groove -width 125 
    checkbutton $base.fra22.che17 \
        -command MaskBrushedData -font helvetica -text {Hide brushed data} \
        -variable mask_brushed_data 
    checkbutton $base.fra22.che18 \
        -command MaskUnbrushedData -font helvetica \
        -text {Hide unbrushed data} -variable mask_unbrushed_data 
    frame $base.fra17 \
        -borderwidth 2 -height 75 -relief groove -width 125 
    checkbutton $base.fra17.che18 \
        -command MaskBrush -font helvetica -text {Hide the brush} \
        -variable mask_brush 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.fra22 \
        -x 5 -y 5 -width 235 -height 70 -anchor nw -bordermode ignore 
    place $base.fra22.che17 \
        -x 5 -y 5 -width 198 -height 37 -anchor nw -bordermode ignore 
    place $base.fra22.che18 \
        -x 5 -y 45 -width 217 -height 22 -anchor nw -bordermode ignore 
    place $base.fra17 \
        -x 5 -y 85 -width 235 -height 35 -anchor nw -bordermode ignore 
    place $base.fra17.che18 \
        -x 5 -y 5 -width 164 -height 27 -anchor nw -bordermode ignore 
}

proc vTclWindow.top21 {base} {
    if {$base == ""} {
        set base .top21
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 774x231+137+61
    wm maxsize $base 1265 994
    wm minsize $base 132 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "Define Brush Operation"
    frame $base.fra22 \
        -borderwidth 1 -height 84 -relief sunken -width 54 
    label $base.fra22.01 \
        -background gray -font menufont -relief raised -text Operations 
    frame $base.fra22.02 \
        -borderwidth 2 -height 75 -relief groove -width 125 
    checkbutton $base.fra22.02.che17 \
        -anchor w -font menufont -highlightthickness 0 -text Values \
        -variable bt_values 
    checkbutton $base.fra22.02.che18 \
        -anchor w -font menufont -highlightthickness 0 -text Average \
        -variable bt_average 
    frame $base.fra22.02.fra19 \
        -borderwidth 2 -height 75 -width 125 
    radiobutton $base.fra22.02.fra19.rad20 \
        -anchor w -command {#appSetBrushOperationType 0} -font menufont \
        -highlightthickness 0 -justify left -text Highlight -value highlight \
        -variable brBrushOpType 
    radiobutton $base.fra22.02.fra19.rad21 \
        -anchor w -command {#appSetBrushOperationType 1} -font menufont \
        -highlightthickness 0 -justify left -text Delete -value mask \
        -variable brBrushOpType 
    frame $base.fra24 \
        -borderwidth 1 -height 76 -relief sunken -width 145 
    label $base.fra24.lab25 \
        -background gray -font menufont -relief raised \
        -text {Brush Expression} 
    frame $base.fra24.fra17 \
        -borderwidth 2 -height 75 -width 125 
    frame $base.fra24.fra17.fra18 \
        -borderwidth 2 -height 75 -relief groove -width 125 
    checkbutton $base.fra24.fra17.fra18.che23 \
        -font menufont -indicatoron 0 -selectcolor #d9d9d9 -text NOT \
        -variable bt_not(1) 
    frame $base.fra24.fra17.fra20 \
        -height 75 -relief groove -width 125 
    radiobutton $base.fra24.fra17.fra20.rad28 \
        -command {toggleBrushes 1 2} -font menufont -highlightthickness 0 \
        -text 2 -value 2 -variable br_brush(1) 
    radiobutton $base.fra24.fra17.fra20.rad30 \
        -command {toggleBrushes 1 1} -font menufont -highlightthickness 0 \
        -text 1 -value 1 -variable br_brush(1) 
    radiobutton $base.fra24.fra17.fra20.rad31 \
        -command {#appSetBrushExpressionType 0 0 2} -font menufont \
        -highlightthickness 0 -text 3 -value 3 -variable br_brush(1) 
    radiobutton $base.fra24.fra17.fra20.rad32 \
        -command {#appSetBrushExpressionType 0 0 3} -font menufont \
        -highlightthickness 0 -text 4 -value 4 -variable br_brush(1) 
    frame $base.fra24.fra17.fra21 \
        -borderwidth 2 -height 75 -relief groove -width 125 
    radiobutton $base.fra24.fra17.fra21.rad33 \
        -command {#appSetBrushExpressionType 1 0 0} -font menufont \
        -highlightthickness 0 -text AND -value and -variable conjunc(1) 
    radiobutton $base.fra24.fra17.fra21.rad34 \
        -anchor nw -command {#appSetBrushExpressionType 1 0 1} -font menufont \
        -highlightthickness 0 -text OR -value or -variable conjunc(1) 
    radiobutton $base.fra24.fra17.fra21.rad35 \
        -command {#appSetBrushExpressionType 1 0 2} -font menufont \
        -highlightthickness 0 -text XOR -value xor -variable conjunc(1) 
    frame $base.fra24.fra17.fra36 \
        -borderwidth 2 -height 75 -relief groove -width 125 
    checkbutton $base.fra24.fra17.fra36.01 \
        -font menufont -indicatoron 0 -selectcolor #d9d9d9 -text NOT \
        -variable bt_not(2) 
    frame $base.fra24.fra17.fra37 \
        -height 75 -relief groove -width 125 
    radiobutton $base.fra24.fra17.fra37.01 \
        -command {#appSetBrushExpressionType 0 1 1} -font menufont \
        -highlightthickness 0 -text 2 -value 2 -variable br_brush(2) 
    radiobutton $base.fra24.fra17.fra37.02 \
        -command {#appSetBrushExpressionType 0 1 0} -font menufont \
        -highlightthickness 0 -text 1 -value 1 -variable br_brush(2) 
    radiobutton $base.fra24.fra17.fra37.03 \
        -command {#appSetBrushExpressionType 0 1 2} -font menufont \
        -highlightthickness 0 -text 3 -value 3 -variable br_brush(2) 
    radiobutton $base.fra24.fra17.fra37.04 \
        -command {#appSetBrushExpressionType 0 1 3} -font menufont \
        -highlightthickness 0 -text 4 -value 4 -variable br_brush(2) 
    frame $base.fra24.fra17.fra38 \
        -borderwidth 2 -height 75 -relief groove -width 125 
    radiobutton $base.fra24.fra17.fra38.01 \
        -command {#appSetBrushExpressionType 1 1 0} -font menufont \
        -highlightthickness 0 -text AND -value and -variable conjunc(2) 
    radiobutton $base.fra24.fra17.fra38.02 \
        -anchor nw -command {#appSetBrushExpressionType 1 1 1} -font menufont \
        -highlightthickness 0 -text OR -value or -variable conjunc(2) 
    radiobutton $base.fra24.fra17.fra38.03 \
        -command {#appSetBrushExpressionType 1 1 2} -font menufont \
        -highlightthickness 0 -text XOR -value xor -variable conjunc(2) 
    frame $base.fra24.fra17.fra39 \
        -borderwidth 2 -height 75 -relief groove -width 125 
    checkbutton $base.fra24.fra17.fra39.01 \
        -font menufont -indicatoron 0 -selectcolor #d9d9d9 -text NOT \
        -variable bt_not(3) 
    frame $base.fra24.fra17.fra40 \
        -height 75 -relief groove -width 125 
    radiobutton $base.fra24.fra17.fra40.01 \
        -command {#appSetBrushExpressionType 0 2 1} -font menufont \
        -highlightthickness 0 -text 2 -value 2 -variable br_brush(3) 
    radiobutton $base.fra24.fra17.fra40.02 \
        -command {#appSetBrushExpressionType 0 2 0} -font menufont \
        -highlightthickness 0 -text 1 -value 1 -variable br_brush(3) 
    radiobutton $base.fra24.fra17.fra40.03 \
        -command {#appSetBrushExpressionType 0 2 2} -font menufont \
        -highlightthickness 0 -text 3 -value 3 -variable br_brush(3) 
    radiobutton $base.fra24.fra17.fra40.04 \
        -command {#appSetBrushExpressionType 0 2 3} -font menufont \
        -highlightthickness 0 -text 4 -value 4 -variable br_brush(3) 
    frame $base.fra24.fra17.fra41 \
        -borderwidth 2 -height 75 -relief groove -width 125 
    radiobutton $base.fra24.fra17.fra41.01 \
        -command {#appSetBrushExpressionType 1 2 0} -font menufont \
        -highlightthickness 0 -text AND -value and -variable conjunc(3) 
    radiobutton $base.fra24.fra17.fra41.02 \
        -anchor nw -command {#appSetBrushExpressionType 1 2 1} -font menufont \
        -highlightthickness 0 -text OR -value or -variable conjunc(3) 
    radiobutton $base.fra24.fra17.fra41.03 \
        -command {#appSetBrushExpressionType 1 2 2} -font menufont \
        -highlightthickness 0 -text XOR -value xor -variable conjunc(3) 
    frame $base.fra24.fra17.fra42 \
        -borderwidth 2 -height 75 -relief groove -width 125 
    checkbutton $base.fra24.fra17.fra42.01 \
        -font menufont -indicatoron 0 -selectcolor #d9d9d9 -text NOT \
        -variable bt_not(4) 
    frame $base.fra24.fra17.fra43 \
        -height 75 -relief groove -width 125 
    radiobutton $base.fra24.fra17.fra43.01 \
        -command {#appSetBrushExpressionType 0 3 1} -font menufont \
        -highlightthickness 0 -text 2 -value 2 -variable br_brush(4) 
    radiobutton $base.fra24.fra17.fra43.02 \
        -command {#appSetBrushExpressionType 0 3 0} -font menufont \
        -highlightthickness 0 -text 1 -value 1 -variable br_brush(4) 
    radiobutton $base.fra24.fra17.fra43.03 \
        -command {#appSetBrushExpressionType 0 3 2} -font menufont \
        -highlightthickness 0 -text 3 -value 3 -variable br_brush(4) 
    radiobutton $base.fra24.fra17.fra43.04 \
        -command {#appSetBrushExpressionType 0 3 3} -font menufont \
        -highlightthickness 0 -text 4 -value 4 -variable br_brush(4) 
    frame $base.fra48 \
        -borderwidth 2 -height 75 -relief sunken -width 125 
    button $base.fra48.but17 \
        -command ClearBrushOperDialog -font menufont -padx 9 -pady 3 \
        -text Clear 
    button $base.fra48.but51 \
        -command {Window hide [W BrushOperationDialog]} -font menufont \
        -padx 9 -pady 3 -text Cancel 
    button $base.fra48.but50 \
        \
        -command {global curr_brushOp new_brushop brBrushOpType bt_values bt_average br_brush bt_not conjunc
if {$new_brushop == "true"} {
    set cur_brushOp [[W list_BrushOps] index end]
    incr cur_brushOp
    appNewBrushOps
}

appFormBrushExpr $cur_brushOp $brBrushOpType $bt_values $bt_average $bt_not(1) $bt_not(2) $bt_not(3) $bt_not(4) $br_brush(1) $br_brush(2) $br_brush(3) $br_brush(4) $conjunc(1) $conjunc(2) $conjunc(3)
RebuiltBrushOpsList
Window hide [W BrushOperationDialog]} \
        -font menufont -padx 9 -pady 3 -text OK 
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.fra22 \
        -in .top21 -anchor center -expand 0 -fill both -ipadx 4 -ipady 4 \
        -padx 6 -pady 4 -side left 
    pack $base.fra22.01 \
        -in .top21.fra22 -anchor center -expand 0 -fill x -ipady 2 -padx 8 \
        -pady 4 -side top 
    pack $base.fra22.02 \
        -in .top21.fra22 -anchor center -expand 1 -fill y -padx 4 -pady 1 \
        -side top 
    grid rowconf $base.fra22.02 0 -weight 2
    grid rowconf $base.fra22.02 1 -weight 1
    grid rowconf $base.fra22.02 2 -weight 1
    grid $base.fra22.02.che17 \
        -in .top21.fra22.02 -column 0 -row 1 -columnspan 1 -rowspan 1 \
        -ipadx 4 -padx 1 -pady 2 -sticky nesw 
    grid $base.fra22.02.che18 \
        -in .top21.fra22.02 -column 0 -row 2 -columnspan 1 -rowspan 1 \
        -ipadx 4 -padx 1 -pady 2 -sticky nesw 
    grid $base.fra22.02.fra19 \
        -in .top21.fra22.02 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.fra22.02.fra19.rad20 \
        -in .top21.fra22.02.fra19 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -padx 1 -pady 2 -sticky nesw 
    grid $base.fra22.02.fra19.rad21 \
        -in .top21.fra22.02.fra19 -column 0 -row 1 -columnspan 1 -rowspan 1 \
        -padx 1 -pady 2 -sticky nesw 
    pack $base.fra24 \
        -in .top21 -anchor center -expand 1 -fill both -padx 6 -pady 4 \
        -side top 
    pack $base.fra24.lab25 \
        -in .top21.fra24 -anchor center -expand 0 -fill x -ipady 2 -padx 8 \
        -pady 4 -side top 
    pack $base.fra24.fra17 \
        -in .top21.fra24 -anchor n -expand 1 -fill x -pady 1 -side top 
    grid $base.fra24.fra17.fra18 \
        -in .top21.fra24.fra17 -column 0 -row 0 -columnspan 1 -rowspan 1 
    grid $base.fra24.fra17.fra18.che23 \
        -in .top21.fra24.fra17.fra18 -column 0 -row 2 -columnspan 1 \
        -rowspan 1 
    grid $base.fra24.fra17.fra20 \
        -in .top21.fra24.fra17 -column 1 -row 0 -columnspan 1 -rowspan 1 
    grid $base.fra24.fra17.fra20.rad28 \
        -in .top21.fra24.fra17.fra20 -column 0 -row 1 -columnspan 1 \
        -rowspan 1 
    grid $base.fra24.fra17.fra20.rad30 \
        -in .top21.fra24.fra17.fra20 -column 0 -row 0 -columnspan 1 \
        -rowspan 1 
    grid $base.fra24.fra17.fra20.rad31 \
        -in .top21.fra24.fra17.fra20 -column 0 -row 2 -columnspan 1 \
        -rowspan 1 
    grid $base.fra24.fra17.fra20.rad32 \
        -in .top21.fra24.fra17.fra20 -column 0 -row 3 -columnspan 1 \
        -rowspan 1 
    grid $base.fra24.fra17.fra21 \
        -in .top21.fra24.fra17 -column 2 -row 0 -columnspan 1 -rowspan 1 
    grid $base.fra24.fra17.fra21.rad33 \
        -in .top21.fra24.fra17.fra21 -column 0 -row 0 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra24.fra17.fra21.rad34 \
        -in .top21.fra24.fra17.fra21 -column 0 -row 1 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra24.fra17.fra21.rad35 \
        -in .top21.fra24.fra17.fra21 -column 0 -row 2 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra24.fra17.fra36 \
        -in .top21.fra24.fra17 -column 3 -row 0 -columnspan 1 -rowspan 1 
    grid $base.fra24.fra17.fra36.01 \
        -in .top21.fra24.fra17.fra36 -column 0 -row 2 -columnspan 1 \
        -rowspan 1 
    grid $base.fra24.fra17.fra37 \
        -in .top21.fra24.fra17 -column 4 -row 0 -columnspan 1 -rowspan 1 
    grid $base.fra24.fra17.fra37.01 \
        -in .top21.fra24.fra17.fra37 -column 0 -row 1 -columnspan 1 \
        -rowspan 1 
    grid $base.fra24.fra17.fra37.02 \
        -in .top21.fra24.fra17.fra37 -column 0 -row 0 -columnspan 1 \
        -rowspan 1 
    grid $base.fra24.fra17.fra37.03 \
        -in .top21.fra24.fra17.fra37 -column 0 -row 2 -columnspan 1 \
        -rowspan 1 
    grid $base.fra24.fra17.fra37.04 \
        -in .top21.fra24.fra17.fra37 -column 0 -row 3 -columnspan 1 \
        -rowspan 1 
    grid $base.fra24.fra17.fra38 \
        -in .top21.fra24.fra17 -column 5 -row 0 -columnspan 1 -rowspan 1 
    grid $base.fra24.fra17.fra38.01 \
        -in .top21.fra24.fra17.fra38 -column 0 -row 0 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra24.fra17.fra38.02 \
        -in .top21.fra24.fra17.fra38 -column 0 -row 1 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra24.fra17.fra38.03 \
        -in .top21.fra24.fra17.fra38 -column 0 -row 2 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra24.fra17.fra39 \
        -in .top21.fra24.fra17 -column 6 -row 0 -columnspan 1 -rowspan 1 
    grid $base.fra24.fra17.fra39.01 \
        -in .top21.fra24.fra17.fra39 -column 0 -row 2 -columnspan 1 \
        -rowspan 1 
    grid $base.fra24.fra17.fra40 \
        -in .top21.fra24.fra17 -column 7 -row 0 -columnspan 1 -rowspan 1 
    grid $base.fra24.fra17.fra40.01 \
        -in .top21.fra24.fra17.fra40 -column 0 -row 1 -columnspan 1 \
        -rowspan 1 
    grid $base.fra24.fra17.fra40.02 \
        -in .top21.fra24.fra17.fra40 -column 0 -row 0 -columnspan 1 \
        -rowspan 1 
    grid $base.fra24.fra17.fra40.03 \
        -in .top21.fra24.fra17.fra40 -column 0 -row 2 -columnspan 1 \
        -rowspan 1 
    grid $base.fra24.fra17.fra40.04 \
        -in .top21.fra24.fra17.fra40 -column 0 -row 3 -columnspan 1 \
        -rowspan 1 
    grid $base.fra24.fra17.fra41 \
        -in .top21.fra24.fra17 -column 8 -row 0 -columnspan 1 -rowspan 1 
    grid $base.fra24.fra17.fra41.01 \
        -in .top21.fra24.fra17.fra41 -column 0 -row 0 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra24.fra17.fra41.02 \
        -in .top21.fra24.fra17.fra41 -column 0 -row 1 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra24.fra17.fra41.03 \
        -in .top21.fra24.fra17.fra41 -column 0 -row 2 -columnspan 1 \
        -rowspan 1 -sticky nesw 
    grid $base.fra24.fra17.fra42 \
        -in .top21.fra24.fra17 -column 9 -row 0 -columnspan 1 -rowspan 1 
    grid $base.fra24.fra17.fra42.01 \
        -in .top21.fra24.fra17.fra42 -column 0 -row 2 -columnspan 1 \
        -rowspan 1 
    grid $base.fra24.fra17.fra43 \
        -in .top21.fra24.fra17 -column 10 -row 0 -columnspan 1 -rowspan 1 
    grid $base.fra24.fra17.fra43.01 \
        -in .top21.fra24.fra17.fra43 -column 0 -row 1 -columnspan 1 \
        -rowspan 1 
    grid $base.fra24.fra17.fra43.02 \
        -in .top21.fra24.fra17.fra43 -column 0 -row 0 -columnspan 1 \
        -rowspan 1 
    grid $base.fra24.fra17.fra43.03 \
        -in .top21.fra24.fra17.fra43 -column 0 -row 2 -columnspan 1 \
        -rowspan 1 
    grid $base.fra24.fra17.fra43.04 \
        -in .top21.fra24.fra17.fra43 -column 0 -row 3 -columnspan 1 \
        -rowspan 1 
    pack $base.fra48 \
        -in .top21 -anchor center -expand 1 -fill x -padx 6 -pady 2 -side top 
    pack $base.fra48.but17 \
        -in .top21.fra48 -anchor center -expand 1 -fill x -padx 4 -pady 4 \
        -side left 
    pack $base.fra48.but51 \
        -in .top21.fra48 -anchor center -expand 1 -fill x -padx 4 -pady 4 \
        -side left 
    pack $base.fra48.but50 \
        -in .top21.fra48 -anchor center -expand 1 -fill x -padx 4 -pady 4 \
        -side left 
}

proc vTclWindow.top22 {base} {
    if {$base == ""} {
        set base .top22
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -cursor xterm 
    wm focusmodel $base passive
    wm geometry $base 549x526+209+423
    wm maxsize $base 1265 994
    wm minsize $base 132 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "Help"
    frame $base.cpd24 \
        -borderwidth 1 -height 30 -relief raised -width 30 
    scrollbar $base.cpd24.01 \
        -background gray -borderwidth 1 -command {.top22.cpd24.03 xview} \
        -orient horiz -troughcolor gray -width 10 
    scrollbar $base.cpd24.02 \
        -activebackground gray -background gray -borderwidth 1 \
        -command {.top22.cpd24.03 yview} -orient vert -troughcolor gray \
        -width 10 
    text $base.cpd24.03 \
        -background white -font textfont -foreground black -height 1 \
        -insertbackground black -selectbackground black \
        -selectforeground white -width 8 -wrap none \
        -xscrollcommand {.top22.cpd24.01 set} \
        -yscrollcommand {.top22.cpd24.02 set} 
    button $base.but25 \
        -command {Window hide [W HelpDialog]} -font menufont -padx 9 -pady 2 \
        -text OK 
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.cpd24 \
        -in .top22 -anchor center -expand 1 -fill both -side top 
    grid columnconf $base.cpd24 0 -weight 1
    grid rowconf $base.cpd24 0 -weight 1
    grid $base.cpd24.01 \
        -in .top22.cpd24 -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky ew 
    grid $base.cpd24.02 \
        -in .top22.cpd24 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
    grid $base.cpd24.03 \
        -in .top22.cpd24 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    pack $base.but25 \
        -in .top22 -anchor center -expand 0 -fill x -side top 
}

proc vTclWindow.top23 {base} {
    if {$base == ""} {
        set base .top23
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 314x322+366+315
    wm maxsize $base 1265 994
    wm minsize $base 132 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "Glyph Key Dialog"
    frame $base.fra26 \
        -borderwidth 1 -height 75 -relief sunken -width 125 
    label $base.fra26.lab27 \
        -background gray -font menufont -relief raised -text {Key for Glyphs} 
    frame $base.fra26.fra28 \
        -borderwidth 1 -height 215 -relief raised -width 38 
    scrollbar $base.fra26.fra28.01 \
        -background gray -borderwidth 1 \
        -command {.top23.fra26.fra28.03 xview} -orient horiz \
        -troughcolor gray -width 10 
    scrollbar $base.fra26.fra28.02 \
        -background gray -borderwidth 1 \
        -command {.top23.fra26.fra28.03 yview} -orient vert -troughcolor gray \
        -width 10 
    text $base.fra26.fra28.03 \
        -background white -font fixedfont -foreground black -height 1 \
        -insertbackground black -selectbackground black \
        -selectforeground white -width 8 -wrap none \
        -xscrollcommand {.top23.fra26.fra28.01 set} \
        -yscrollcommand {.top23.fra26.fra28.02 set} 
    frame $base.fra29 \
        -borderwidth 1 -height 75 -relief sunken -width 125 
    button $base.fra29.but30 \
        -command {Window hide [W GlyphKeyDialog]} -font menufont -padx 9 \
        -pady 3 -text OK 
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.fra26 \
        -in .top23 -anchor center -expand 1 -fill both -padx 8 -pady 8 \
        -side top 
    pack $base.fra26.lab27 \
        -in .top23.fra26 -anchor center -expand 0 -fill x -ipady 4 -padx 4 \
        -pady 4 -side top 
    pack $base.fra26.fra28 \
        -in .top23.fra26 -anchor center -expand 1 -fill both -padx 2 -pady 2 \
        -side top 
    grid columnconf $base.fra26.fra28 0 -weight 1
    grid rowconf $base.fra26.fra28 0 -weight 1
    grid $base.fra26.fra28.01 \
        -in .top23.fra26.fra28 -column 0 -row 1 -columnspan 1 -rowspan 1 \
        -sticky ew 
    grid $base.fra26.fra28.02 \
        -in .top23.fra26.fra28 -column 1 -row 0 -columnspan 1 -rowspan 1 \
        -sticky ns 
    grid $base.fra26.fra28.03 \
        -in .top23.fra26.fra28 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    pack $base.fra29 \
        -in .top23 -anchor center -expand 0 -fill x -padx 8 -pady 8 -side top 
    pack $base.fra29.but30 \
        -in .top23.fra29 -anchor center -expand 0 -fill x -padx 4 -pady 4 \
        -side top 
}

proc vTclWindow.top24 {base} {
    if {$base == ""} {
        set base .top24
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 478x406+279+228
    wm maxsize $base 1265 994
    wm minsize $base 132 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "Cluster Tree Construction"
    label $base.lab25 \
        -background gray -borderwidth 1 -font menufont -pady 5 -relief raised \
        -text {Birch Subprogram} 
    frame $base.cpd26 \
        -borderwidth 1 -height 30 -relief raised -width 30 
    scrollbar $base.cpd26.01 \
        -background gray -borderwidth 1 -command {.top24.cpd26.03 xview} \
        -orient horiz -troughcolor gray -width 10 
    scrollbar $base.cpd26.02 \
        -background gray -borderwidth 1 -command {.top24.cpd26.03 yview} \
        -orient vert -troughcolor gray -width 10 
    text $base.cpd26.03 \
        -background white -font textfont -foreground black -height 1 \
        -insertbackground black -selectbackground black \
        -selectforeground white -width 8 \
        -xscrollcommand {.top24.cpd26.01 set} \
        -yscrollcommand {.top24.cpd26.02 set} 
    button $base.but27 \
        -command {Window destroy [W BirchDialog]} -font menufont -padx 9 \
        -pady 5 -text OK 
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.lab25 \
        -in .top24 -anchor center -expand 0 -fill x -side top 
    pack $base.cpd26 \
        -in .top24 -anchor center -expand 1 -fill both -side top 
    grid columnconf $base.cpd26 0 -weight 1
    grid rowconf $base.cpd26 0 -weight 1
    grid $base.cpd26.01 \
        -in .top24.cpd26 -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky ew 
    grid $base.cpd26.02 \
        -in .top24.cpd26 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
    grid $base.cpd26.03 \
        -in .top24.cpd26 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    pack $base.but27 \
        -in .top24 -anchor center -expand 0 -fill x -side top 
}

proc vTclWindow.top25 {base} {
    if {$base == ""} {
        set base .top25
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -menu .top25.m34 
    wm focusmodel $base passive
    wm geometry $base 479x767+515+121
    wm maxsize $base 1028 748
    wm minsize $base 132 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "Glyph Placement"
    frame $base.fra28 \
        -borderwidth 2 -height 75 -width 125 
    frame $base.fra28.fra29 \
        -borderwidth 2 -height 75 -relief groove -width 125 
    radiobutton $base.fra28.rad36 \
        -command {SetGlyphPlacementDialog "original"} -font helvetica \
        -text original -value original -variable glyph_placement_kind 
    radiobutton $base.fra28.rad37 \
        -command {SetGlyphPlacementDialog "ordered"} -font helvetica \
        -text ordered -value ordered -variable glyph_placement_kind 
    radiobutton $base.fra28.rad38 \
        -command {SetGlyphPlacementDialog "derived"} -font helvetica \
        -text derived -value derived -variable glyph_placement_kind 
    radiobutton $base.fra28.rad39 \
        -command {SetGlyphPlacementDialog "data_driven"} -font helvetica \
        -text data_driven -value data_driven -variable glyph_placement_kind 
    frame $base.fra28.fra45 \
        -borderwidth 2 -cursor fleur -height 75 -relief ridge -width 125 
    checkbutton $base.fra28.fra45.01 \
        -font helvetica -state disabled -text Increase \
        -variable glyph_placement_increase 
    entry $base.fra28.fra45.02 \
        -font helvetica -relief flat -state disabled 
    frame $base.fra28.fra17 \
        -borderwidth 2 -height 75 -relief ridge -width 125 
    entry $base.fra28.fra17.ent18 \
        -font helvetica -relief flat -state disabled 
    entry $base.fra28.fra17.ent20 \
        -font helvetica -relief flat -state disabled 
    button $base.fra28.fra17.but21 \
        -command {ClickGlyphPDSelectButton "X"} -font helvetica \
        -state disabled -text {Select X} 
    button $base.fra28.fra17.but22 \
        -command {ClickGlyphPDSelectButton "Y"} -font helvetica \
        -state disabled -text {Select Y} 
    checkbutton $base.fra28.fra17.che17 \
        -font helvetica -text {reduce overlap} \
        -variable glyph_placement_shift 
    checkbutton $base.fra28.fra17.che18 \
        -font helvetica -text space -variable glyph_placement_space 
    frame $base.fra30 \
        -borderwidth 2 -height 75 -relief ridge -width 125 
    listbox $base.fra30.lis32 \
        -font helvetica -relief flat -selectmode single \
        -yscrollcommand {.top25.fra30.scr33 set} 
    bind $base.fra30.lis32 <ButtonRelease-1> {
        ListSelectEnd %W %y
    }
    scrollbar $base.fra30.scr33 \
        -command {.top25.fra30.lis32 yview} -orient vert 
    menu $base.m34 \
        -activeborderwidth 1 -borderwidth 1 -cursor {} -font helvetica 
    button $base.but35 \
        -command GlyphPlacementDialogOK -font helvetica -text Apply 
    button $base.but36 \
        -command GlyphPlacementDialogCancel -font helvetica -text OK 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.fra28 \
        -x 5 -y 0 -width 470 -height 180 -anchor nw -bordermode ignore 
    place $base.fra28.fra29 \
        -x 50 -y 210 -anchor nw -bordermode ignore 
    place $base.fra28.rad36 \
        -x 5 -y 5 -width 102 -height 22 -anchor nw -bordermode ignore 
    place $base.fra28.rad37 \
        -x 115 -y 5 -width 102 -height 22 -anchor nw -bordermode ignore 
    place $base.fra28.rad38 \
        -x 365 -y 5 -width 102 -height 22 -anchor nw -bordermode ignore 
    place $base.fra28.rad39 \
        -x 225 -y 5 -width 140 -height 22 -anchor nw -bordermode ignore 
    place $base.fra28.fra45 \
        -x 10 -y 30 -width 450 -height 40 -anchor nw -bordermode ignore 
    place $base.fra28.fra45.01 \
        -x 10 -y 5 -width 104 -height 27 -anchor nw -bordermode ignore 
    place $base.fra28.fra45.02 \
        -x 120 -y 5 -width 321 -height 29 -anchor nw -bordermode ignore 
    place $base.fra28.fra17 \
        -x 10 -y 75 -width 450 -height 100 -anchor nw -bordermode ignore 
    place $base.fra28.fra17.ent18 \
        -x 120 -y 5 -width 321 -height 29 -anchor nw -bordermode ignore 
    place $base.fra28.fra17.ent20 \
        -x 120 -y 40 -width 321 -height 29 -anchor nw -bordermode ignore 
    place $base.fra28.fra17.but21 \
        -x 10 -y 5 -width 102 -height 28 -anchor nw -bordermode ignore 
    place $base.fra28.fra17.but22 \
        -x 10 -y 40 -width 102 -height 28 -anchor nw -bordermode ignore 
    place $base.fra28.fra17.che17 \
        -x 130 -y 75 -width 164 -height 22 -anchor nw -bordermode ignore 
    place $base.fra28.fra17.che18 \
        -x 10 -y 75 -width 89 -height 22 -anchor nw -bordermode ignore 
    place $base.fra30 \
        -x 5 -y 185 -width 470 -height 215 -anchor nw -bordermode ignore 
    place $base.fra30.lis32 \
        -x 5 -y 5 -width 438 -height 206 -anchor nw -bordermode ignore 
    place $base.fra30.scr33 \
        -x 445 -y 5 -width 20 -height 205 -anchor nw -bordermode ignore 
    place $base.but35 \
        -x 85 -y 405 -width 79 -height 28 -anchor nw -bordermode ignore 
    place $base.but36 \
        -x 280 -y 405 -width 75 -height 28 -anchor nw -bordermode ignore 
}

proc vTclWindow.top26 {base} {
    if {$base == ""} {
        set base .top26
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 651x389+43+264
    wm maxsize $base 1265 994
    wm minsize $base 132 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "Dataset Summary Dialog"
    frame $base.fra28 \
        -borderwidth 1 -height 75 -relief sunken -width 125 
    frame $base.fra28.fra46 \
        -height 150 -width 249 
    label $base.fra28.fra46.lab47 \
        -anchor e -background gray -borderwidth 1 -font menufont \
        -justify left -padx 5 -pady 5 -relief raised -text {File name} 
    entry $base.fra28.fra46.ent48 \
        -font menufont -relief ridge -textvariable t_filename 
    label $base.fra28.fra46.lab49 \
        -anchor e -background gray -borderwidth 1 -font menufont -padx 5 \
        -pady 5 -relief raised -text {Data path} 
    entry $base.fra28.fra46.ent50 \
        -font menufont -relief groove 
    label $base.fra28.fra46.lab51 \
        -anchor e -background gray -borderwidth 1 -font menufont \
        -justify left -padx 5 -pady 5 -relief raised \
        -text {File size (bytes)} 
    entry $base.fra28.fra46.ent52 \
        -font menufont -relief groove 
    entry $base.fra28.fra46.ent53 \
        -font menufont -relief groove 
    label $base.fra28.fra46.lab54 \
        -anchor e -background gray -borderwidth 1 -font menufont \
        -justify left -padx 5 -pady 5 -relief raised \
        -text {Number of records} 
    label $base.fra28.fra46.lab55 \
        -anchor e -background gray -borderwidth 1 -font menufont -padx 5 \
        -pady 5 -relief raised -text Dimensions 
    entry $base.fra28.fra46.ent56 \
        -font menufont -relief groove 
    frame $base.fra28.fra58 \
        -borderwidth 1 -height 90 -relief raised -width 113 
    scrollbar $base.fra28.fra58.01 \
        -background gray -borderwidth 1 \
        -command {.top26.fra28.fra58.03 xview} -orient horiz \
        -troughcolor gray -width 10 
    scrollbar $base.fra28.fra58.02 \
        -background gray -borderwidth 1 \
        -command {.top26.fra28.fra58.03 yview} -orient vert -troughcolor gray \
        -width 10 
    canvas $base.fra28.fra58.03 \
        -borderwidth 2 -height 100 -relief ridge -width 100 \
        -xscrollcommand {.top26.fra28.fra58.01 set} \
        -yscrollcommand {.top26.fra28.fra58.02 set} 
    frame $base.fra37 \
        -borderwidth 1 -height 75 -relief sunken -width 125 
    button $base.fra37.but38 \
        -command {
Window hide [W DataSummaryDialog]} -font menufont -padx 9 \
        -pady 5 -text OK 
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.fra28 \
        -in .top26 -anchor center -expand 1 -fill both -padx 5 -pady 5 \
        -side top 
    pack $base.fra28.fra46 \
        -in .top26.fra28 -anchor w -expand 0 -fill x -padx 8 -pady 8 \
        -side top 
    grid columnconf $base.fra28.fra46 0 -weight 1
    grid columnconf $base.fra28.fra46 1 -weight 1
    grid columnconf $base.fra28.fra46 2 -weight 1
    grid columnconf $base.fra28.fra46 3 -weight 1
    grid rowconf $base.fra28.fra46 1 -weight 1
    grid rowconf $base.fra28.fra46 2 -weight 1
    grid rowconf $base.fra28.fra46 3 -weight 1
    grid $base.fra28.fra46.lab47 \
        -in .top26.fra28.fra46 -column 0 -row 1 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.fra28.fra46.ent48 \
        -in .top26.fra28.fra46 -column 1 -row 1 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.fra28.fra46.lab49 \
        -in .top26.fra28.fra46 -column 2 -row 1 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.fra28.fra46.ent50 \
        -in .top26.fra28.fra46 -column 3 -row 1 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.fra28.fra46.lab51 \
        -in .top26.fra28.fra46 -column 0 -row 2 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.fra28.fra46.ent52 \
        -in .top26.fra28.fra46 -column 1 -row 2 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.fra28.fra46.ent53 \
        -in .top26.fra28.fra46 -column 3 -row 2 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.fra28.fra46.lab54 \
        -in .top26.fra28.fra46 -column 2 -row 2 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.fra28.fra46.lab55 \
        -in .top26.fra28.fra46 -column 0 -row 3 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.fra28.fra46.ent56 \
        -in .top26.fra28.fra46 -column 1 -row 3 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    pack $base.fra28.fra58 \
        -in .top26.fra28 -anchor center -expand 1 -fill both -padx 4 -pady 4 \
        -side top 
    grid columnconf $base.fra28.fra58 0 -weight 1
    grid rowconf $base.fra28.fra58 0 -weight 1
    grid $base.fra28.fra58.01 \
        -in .top26.fra28.fra58 -column 0 -row 1 -columnspan 1 -rowspan 1 \
        -sticky ew 
    grid $base.fra28.fra58.02 \
        -in .top26.fra28.fra58 -column 1 -row 0 -columnspan 1 -rowspan 1 \
        -sticky ns 
    grid $base.fra28.fra58.03 \
        -in .top26.fra28.fra58 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    pack $base.fra37 \
        -in .top26 -anchor center -expand 0 -fill x -padx 8 -pady 8 -side top 
    pack $base.fra37.but38 \
        -in .top26.fra37 -anchor center -expand 0 -fill both -padx 4 -pady 4 \
        -side top 
}

proc vTclWindow.top27 {base} {
    if {$base == ""} {
        set base .top27
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 280x411+555+280
    wm maxsize $base 1265 994
    wm minsize $base 132 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "About"
    frame $base.fra36 \
        -borderwidth 3 -height 75 -relief ridge -width 125 
    label $base.fra36.lab37 \
        -background #00a2be -borderwidth 1 -font menufont -image logo \
        -relief raised -text label 
    frame $base.fra38 \
        -borderwidth 3 -height 75 -relief ridge -width 125 
    label $base.fra38.lab40 \
        -background gray -borderwidth 1 -font menufont -relief raised \
        -text {Copyright 1994-1999} 
    label $base.fra38.lab41 \
        -background gray -borderwidth 1 -font menufont -relief raised \
        -text {Matthew O. Ward, Allen R. Martin} 
    label $base.fra38.lab42 \
        -background gray -borderwidth 1 -font menufont -relief raised \
        -text {Ying-Huey Fua, Jing Yang} 
    label $base.fra38.lab43 \
        -background gray -borderwidth 1 -font menufont -relief raised \
        -text {Worcester Polytechnic Institute} 
    label $base.fra38.lab44 \
        -background gray -borderwidth 1 -font menufont -relief raised \
        -text (matt@cs.wpi.edu) 
    label $base.fra38.lab45 \
        -background gray -borderwidth 1 -font menufont -relief raised \
        -text {Release 4.2 Beta} 
    button $base.fra38.but46 \
        -command {
Window hide [W AboutDialog]} -font menufont -padx 9 \
        -pady 3 -text OK 
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.fra36 \
        -in .top27 -anchor center -expand 1 -fill both -padx 3 -pady 3 \
        -side top 
    pack $base.fra36.lab37 \
        -in .top27.fra36 -anchor center -expand 1 -fill both -side top 
    pack $base.fra38 \
        -in .top27 -anchor center -expand 1 -fill both -padx 3 -pady 3 \
        -side top 
    pack $base.fra38.lab40 \
        -in .top27.fra38 -anchor center -expand 1 -fill both -side top 
    pack $base.fra38.lab41 \
        -in .top27.fra38 -anchor center -expand 1 -fill both -side top 
    pack $base.fra38.lab42 \
        -in .top27.fra38 -anchor center -expand 1 -fill both -side top 
    pack $base.fra38.lab43 \
        -in .top27.fra38 -anchor center -expand 1 -fill both -side top 
    pack $base.fra38.lab44 \
        -in .top27.fra38 -anchor center -expand 1 -fill both -side top 
    pack $base.fra38.lab45 \
        -in .top27.fra38 -anchor center -expand 1 -fill both -side top 
    pack $base.fra38.but46 \
        -in .top27.fra38 -anchor center -expand 1 -fill both -side top 
}

proc vTclWindow.top28 {base} {
    if {$base == ""} {
        set base .top28
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -menu .top28.m44 
    wm focusmodel $base passive
    wm geometry $base 409x589+561+82
    wm maxsize $base 1265 994
    wm minsize $base 132 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "Brush Toolbox"
    frame $base.fra29 \
        -borderwidth 1 -height 75 -relief sunken -width 125 
    label $base.fra29.lab30 \
        -background gray -font menufont -relief raised \
        -text {Global Brush Resize} 
    frame $base.fra29.fra35 \
        -borderwidth 2 -height 75 -relief groove -width 125 
    button $base.fra29.fra35.but36 \
        -command {appGlobalBrushResize "max"} -font menufont -padx 9 -pady 2 \
        -text Max 
    button $base.fra29.fra35.but37 \
        -command {appGlobalBrushResize "half"} -font menufont -padx 9 -pady 2 \
        -text Half 
    button $base.fra29.fra35.but38 \
        -command {appGlobalBrushResize "+"} -font menufont -padx 9 -pady 2 \
        -text +10% 
    button $base.fra29.fra35.but39 \
        -command {appGlobalBrushResize "-"} -font menufont -padx 9 -pady 2 \
        -text -10% 
    frame $base.fra43 \
        -borderwidth 1 -height 57 -relief sunken -width 125 
    label $base.fra43.lab45 \
        -background gray -font menufont -relief raised \
        -text {Brush Selection} 
    frame $base.fra43.fra18 \
        -borderwidth 2 -height 75 -relief groove -width 125 
    button $base.fra43.fra18.but19 \
        -command {SetActiveBrush 1} -font menufont -padx 9 -pady 2 \
        -relief sunken -text 1 -width 3 
    button $base.fra43.fra18.but20 \
        -command {SetBrushEnableState 1} -font menufont -padx 9 -pady 2 \
        -relief sunken -text Enable 
    button $base.fra43.fra18.but21 \
        -command {SetBrushDisplayState 1} -font menufont -padx 9 -pady 2 \
        -relief sunken -text Display 
    radiobutton $base.fra43.fra18.rad22 \
        -command {appSetBrushBoundaryType 0 0} -font menufont \
        -highlightthickness 0 -text Step -value step -variable brType_1 
    radiobutton $base.fra43.fra18.rad23 \
        -command {appSetBrushBoundaryType 0 1} -font menufont \
        -highlightthickness 0 -text Ramp -value ramp -variable brType_1 
    frame $base.fra43.fra17 \
        -borderwidth 2 -height 75 -relief groove -width 125 
    button $base.fra43.fra17.01 \
        -command {SetActiveBrush 2} -font menufont -padx 9 -pady 2 -text 2 \
        -width 3 
    button $base.fra43.fra17.02 \
        -command {SetBrushEnableState 2} -font menufont -padx 9 -pady 2 \
        -text Enable 
    button $base.fra43.fra17.03 \
        -command {SetBrushDisplayState 2} -font menufont -padx 9 -pady 2 \
        -text Display 
    radiobutton $base.fra43.fra17.04 \
        -command {appSetBrushBoundaryType 1 0} -font menufont \
        -highlightthickness 0 -text Step -value step -variable brType_2 
    radiobutton $base.fra43.fra17.05 \
        -command {appSetBrushBoundaryType 1 1} -font menufont \
        -highlightthickness 0 -text Ramp -value ramp -variable brType_2 
    frame $base.fra43.fra19 \
        -borderwidth 2 -height 75 -relief groove -width 125 
    button $base.fra43.fra19.01 \
        -command {SetActiveBrush 3} -font menufont -padx 9 -pady 2 -text 3 \
        -width 3 
    button $base.fra43.fra19.02 \
        -command {SetBrushEnableState 3} -font menufont -padx 9 -pady 2 \
        -text Enable 
    button $base.fra43.fra19.03 \
        -command {SetBrushDisplayState 3} -font menufont -padx 9 -pady 2 \
        -text Display 
    radiobutton $base.fra43.fra19.04 \
        -command {appSetBrushBoundaryType 2 0} -font menufont \
        -highlightthickness 0 -text Step -value step -variable brType_3 
    radiobutton $base.fra43.fra19.05 \
        -command {appSetBrushBoundaryType 2 1} -font menufont \
        -highlightthickness 0 -text Ramp -value ramp -variable brType_3 
    frame $base.fra43.fra20 \
        -borderwidth 2 -height 75 -relief groove -width 125 
    button $base.fra43.fra20.01 \
        -command {SetActiveBrush 4} -font menufont -padx 9 -pady 2 -text 4 \
        -width 3 
    button $base.fra43.fra20.02 \
        -command {SetBrushEnableState 4} -font menufont -padx 9 -pady 2 \
        -text Enable 
    button $base.fra43.fra20.03 \
        -command {SetBrushDisplayState 4} -font menufont -padx 9 -pady 2 \
        -text Display 
    radiobutton $base.fra43.fra20.04 \
        -command {appSetBrushBoundaryType 3 0} -font menufont \
        -highlightthickness 0 -text Step -value step -variable brType_4 
    radiobutton $base.fra43.fra20.05 \
        -command {appSetBrushBoundaryType 3 1} -font menufont \
        -highlightthickness 0 -text Ramp -value ramp -variable brType_4 
    frame $base.fra46 \
        -borderwidth 1 -height 79 -relief sunken -width 117 
    label $base.fra46.lab47 \
        -background gray -font menufont -relief raised \
        -text {Brush Creation/Modification} 
    frame $base.fra46.fra33 \
        -borderwidth 2 -height 75 -relief groove -width 83 
    button $base.fra46.fra33.01 \
        \
        -command {global new_brushop
set new_brushop "true"

ClearBrushOperDialog

Window show [W BrushOperationDialog]
raise [W BrushOperationDialog]} \
        -font menufont -highlightthickness 0 -padx 4 -pady 2 -text New 
    button $base.fra46.fra33.02 \
        \
        -command {set w [[W list_BrushOps] curselection]
#puts "edit op: $w"
if { $w == ""} {
#    puts "Please select a brush operation to edit"
    return;
}    

ClearBrushOperDialog
   
global cur_brushOp
set cur_brushOp [expr $w+1]
set brush_op [appGetBrushOps $cur_brushOp]

global brBrushOpType
set brBrushOpType ""
if { [lindex $brush_op 0] == "1" } {
    set brBrushOpType "highlight"
}
if { [lindex $brush_op 0] == "0" } {
    set brBrushOpType "mask"
}

global bt_values bt_average
set bt_values 0
set bt_average 0
if { [lindex $brush_op 1] == "1" } { 
    set bt_values 1
}
if { [lindex $brush_op 2] == "1" } { 
    set bt_average 1
}

set num_brush [appGetNumBrushes $cur_brushOp]

set idx 1
while {$idx <= $num_brush} {
    set brush_expr [appGetBrushExpr $cur_brushOp $idx]
    set bt_not($idx) [lindex $brush_expr 0]
    set br_brush($idx) [lindex $brush_expr 1]
    set tmp [lindex $brush_expr 2]
    if { $tmp == "1"} { set conjunc($idx) and}
    if { $tmp == "2"} { set conjunc($idx) or}
    if { $tmp == "3"} { set conjunc($idx) xor}
    incr idx
}

global new_brushop
set new_brushop "false"

Window show [W BrushOperationDialog]
raise [W BrushOperationDialog]} \
        -font menufont -highlightthickness 0 -padx 4 -pady 2 -text Edit 
    button $base.fra46.fra33.03 \
        \
        -command {set op_num [ [W list_BrushOps] curselection ]
if { $op_num < 0 } return;
appDeleteBrushOps [expr $op_num + 1]
RebuiltBrushOpsList} \
        -font menufont -highlightthickness 0 -padx 4 -pady 2 -text Delete 
    button $base.fra46.fra33.but17 \
        \
        -command {set index [[W list_BrushOps] curselection]
if { $index < 0 } return;

appRaiseOperPriority [expr $index + 1]
RebuiltBrushOpsList
set new_select [expr $index - 1]
if { $new_select < 0 } { set new_select 0 }
[W list_BrushOps] selection clear 0 end
[W list_BrushOps] selection set $new_select} \
        -font menufont -highlightthickness 0 -padx 4 -pady 3 \
        -text {Incr Priority} 
    button $base.fra46.fra33.but18 \
        \
        -command {set index [[W list_BrushOps] curselection]
if { $index < 0 } return;

appLowerOperPriority [expr $index + 1]
RebuiltBrushOpsList

set new_select [expr $index + 1]
set end_index [expr [[W list_BrushOps] index end] - 1]
if { $new_select > $end_index } { set new_select $end_index  }
[W list_BrushOps] selection clear 0 end
[W list_BrushOps] selection set $new_select} \
        -font menufont -highlightthickness 0 -padx 4 -pady 3 \
        -text {Decr Priority} 
    frame $base.fra46.cpd17 \
        -borderwidth 1 -height 10 -relief raised -width 30 
    listbox $base.fra46.cpd17.01 \
        -font menufont -height 7 -width 11 \
        -xscrollcommand {.top28.fra46.cpd17.02 set} \
        -yscrollcommand {.top28.fra46.cpd17.03 set} 
    scrollbar $base.fra46.cpd17.02 \
        -background gray -borderwidth 1 \
        -command {.top28.fra46.cpd17.01 xview} -orient horiz \
        -troughcolor gray -width 10 
    scrollbar $base.fra46.cpd17.03 \
        -background gray -borderwidth 1 \
        -command {.top28.fra46.cpd17.01 yview} -orient vert -troughcolor gray \
        -width 10 
    frame $base.fra41 \
        -borderwidth 1 -height 75 -relief sunken -width 125 
    button $base.fra41.but42 \
        -command {Window hide [W BrushToolboxDialog]} -font menufont -padx 9 \
        -pady 3 -text OK 
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.fra29 \
        -in .top28 -anchor center -expand 0 -fill x -padx 8 -pady 6 -side top 
    pack $base.fra29.lab30 \
        -in .top28.fra29 -anchor center -expand 0 -fill both -ipadx 4 \
        -ipady 2 -padx 4 -pady 4 -side top 
    pack $base.fra29.fra35 \
        -in .top28.fra29 -anchor center -expand 1 -fill x -padx 2 -pady 2 \
        -side top 
    grid columnconf $base.fra29.fra35 0 -weight 1
    grid columnconf $base.fra29.fra35 2 -weight 1
    grid columnconf $base.fra29.fra35 3 -weight 1
    grid columnconf $base.fra29.fra35 4 -weight 1
    grid $base.fra29.fra35.but36 \
        -in .top28.fra29.fra35 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -padx 1 -pady 2 -sticky nesw 
    grid $base.fra29.fra35.but37 \
        -in .top28.fra29.fra35 -column 2 -row 0 -columnspan 1 -rowspan 1 \
        -padx 1 -pady 2 -sticky nesw 
    grid $base.fra29.fra35.but38 \
        -in .top28.fra29.fra35 -column 3 -row 0 -columnspan 1 -rowspan 1 \
        -padx 1 -pady 2 -sticky nesw 
    grid $base.fra29.fra35.but39 \
        -in .top28.fra29.fra35 -column 4 -row 0 -columnspan 1 -rowspan 1 \
        -padx 1 -pady 2 -sticky nesw 
    pack $base.fra43 \
        -in .top28 -anchor center -expand 0 -fill x -padx 8 -pady 3 -side top 
    pack $base.fra43.lab45 \
        -in .top28.fra43 -anchor center -expand 0 -fill x -ipady 2 -padx 4 \
        -pady 4 -side top 
    pack $base.fra43.fra18 \
        -in .top28.fra43 -anchor center -expand 0 -fill x -padx 4 -pady 1 \
        -side top 
    grid $base.fra43.fra18.but19 \
        -in .top28.fra43.fra18 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -padx 1 -pady 2 
    grid $base.fra43.fra18.but20 \
        -in .top28.fra43.fra18 -column 1 -row 0 -columnspan 1 -rowspan 1 \
        -padx 1 -pady 2 
    grid $base.fra43.fra18.but21 \
        -in .top28.fra43.fra18 -column 2 -row 0 -columnspan 1 -rowspan 1 \
        -padx 1 -pady 2 
    grid $base.fra43.fra18.rad22 \
        -in .top28.fra43.fra18 -column 3 -row 0 -columnspan 1 -rowspan 1 \
        -padx 1 -pady 2 
    grid $base.fra43.fra18.rad23 \
        -in .top28.fra43.fra18 -column 5 -row 0 -columnspan 1 -rowspan 1 \
        -padx 1 -pady 2 
    pack $base.fra43.fra17 \
        -in .top28.fra43 -anchor center -expand 0 -fill x -padx 4 -pady 1 \
        -side top 
    grid $base.fra43.fra17.01 \
        -in .top28.fra43.fra17 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -padx 1 -pady 2 
    grid $base.fra43.fra17.02 \
        -in .top28.fra43.fra17 -column 1 -row 0 -columnspan 1 -rowspan 1 \
        -padx 1 -pady 2 
    grid $base.fra43.fra17.03 \
        -in .top28.fra43.fra17 -column 2 -row 0 -columnspan 1 -rowspan 1 \
        -padx 1 -pady 2 
    grid $base.fra43.fra17.04 \
        -in .top28.fra43.fra17 -column 3 -row 0 -columnspan 1 -rowspan 1 \
        -padx 1 -pady 2 
    grid $base.fra43.fra17.05 \
        -in .top28.fra43.fra17 -column 5 -row 0 -columnspan 1 -rowspan 1 \
        -padx 1 -pady 2 
    pack $base.fra43.fra19 \
        -in .top28.fra43 -anchor center -expand 0 -fill x -padx 4 -pady 1 \
        -side top 
    grid $base.fra43.fra19.01 \
        -in .top28.fra43.fra19 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -padx 1 -pady 2 
    grid $base.fra43.fra19.02 \
        -in .top28.fra43.fra19 -column 1 -row 0 -columnspan 1 -rowspan 1 \
        -padx 1 -pady 2 
    grid $base.fra43.fra19.03 \
        -in .top28.fra43.fra19 -column 2 -row 0 -columnspan 1 -rowspan 1 \
        -padx 1 -pady 2 
    grid $base.fra43.fra19.04 \
        -in .top28.fra43.fra19 -column 3 -row 0 -columnspan 1 -rowspan 1 \
        -padx 1 -pady 2 
    grid $base.fra43.fra19.05 \
        -in .top28.fra43.fra19 -column 5 -row 0 -columnspan 1 -rowspan 1 \
        -padx 1 -pady 2 
    pack $base.fra43.fra20 \
        -in .top28.fra43 -anchor center -expand 0 -fill x -padx 4 -pady 1 \
        -side top 
    grid $base.fra43.fra20.01 \
        -in .top28.fra43.fra20 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -padx 1 -pady 2 
    grid $base.fra43.fra20.02 \
        -in .top28.fra43.fra20 -column 1 -row 0 -columnspan 1 -rowspan 1 \
        -padx 1 -pady 2 
    grid $base.fra43.fra20.03 \
        -in .top28.fra43.fra20 -column 2 -row 0 -columnspan 1 -rowspan 1 \
        -padx 1 -pady 2 
    grid $base.fra43.fra20.04 \
        -in .top28.fra43.fra20 -column 3 -row 0 -columnspan 1 -rowspan 1 \
        -padx 1 -pady 2 
    grid $base.fra43.fra20.05 \
        -in .top28.fra43.fra20 -column 5 -row 0 -columnspan 1 -rowspan 1 \
        -padx 1 -pady 2 
    pack $base.fra46 \
        -in .top28 -anchor center -expand 1 -fill both -padx 8 -pady 4 \
        -side top 
    pack $base.fra46.lab47 \
        -in .top28.fra46 -anchor center -expand 0 -fill x -ipadx 4 -ipady 2 \
        -padx 4 -pady 4 -side top 
    pack $base.fra46.fra33 \
        -in .top28.fra46 -anchor n -expand 1 -fill x -padx 2 -pady 2 \
        -side top 
    grid $base.fra46.fra33.01 \
        -in .top28.fra46.fra33 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -padx 1 -pady 2 -sticky nesw 
    grid $base.fra46.fra33.02 \
        -in .top28.fra46.fra33 -column 1 -row 0 -columnspan 1 -rowspan 1 \
        -padx 1 -pady 2 -sticky nesw 
    grid $base.fra46.fra33.03 \
        -in .top28.fra46.fra33 -column 2 -row 0 -columnspan 1 -rowspan 1 \
        -padx 1 -pady 2 -sticky nesw 
    grid $base.fra46.fra33.but17 \
        -in .top28.fra46.fra33 -column 3 -row 0 -columnspan 1 -rowspan 1 \
        -padx 1 -pady 2 -sticky nesw 
    grid $base.fra46.fra33.but18 \
        -in .top28.fra46.fra33 -column 4 -row 0 -columnspan 1 -rowspan 1 \
        -padx 1 -pady 2 -sticky nesw 
    pack $base.fra46.cpd17 \
        -in .top28.fra46 -anchor n -expand 1 -fill both -side top 
    grid columnconf $base.fra46.cpd17 0 -weight 1
    grid rowconf $base.fra46.cpd17 0 -weight 1
    grid $base.fra46.cpd17.01 \
        -in .top28.fra46.cpd17 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.fra46.cpd17.02 \
        -in .top28.fra46.cpd17 -column 0 -row 1 -columnspan 1 -rowspan 1 \
        -sticky ew 
    grid $base.fra46.cpd17.03 \
        -in .top28.fra46.cpd17 -column 1 -row 0 -columnspan 1 -rowspan 1 \
        -sticky ns 
    pack $base.fra41 \
        -in .top28 -anchor center -expand 0 -fill x -padx 8 -pady 4 -side top 
    pack $base.fra41.but42 \
        -in .top28.fra41 -anchor center -expand 1 -fill x -padx 4 -pady 4 \
        -side top 
}

proc vTclWindow.top29 {base} {
    if {$base == ""} {
        set base .top29
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -cursor xterm -menu .top29.m27 
    wm focusmodel $base passive
    wm geometry $base 716x1013+234+30
    wm maxsize $base 1265 994
    wm minsize $base 132 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "XmdvTool Hypertext Help"
    frame $base.fra30 \
        -borderwidth 1 -height 75 -relief sunken -width 125 
    frame $base.fra30.cpd33 \
        -borderwidth 1 -height 30 -relief raised -width 30 
    scrollbar $base.fra30.cpd33.01 \
        -background gray -borderwidth 1 \
        -command {.top29.fra30.cpd33.03 xview} -orient horiz \
        -troughcolor gray -width 10 
    scrollbar $base.fra30.cpd33.02 \
        -background gray -borderwidth 1 \
        -command {.top29.fra30.cpd33.03 yview} -orient vert -troughcolor gray \
        -width 10 
    text $base.fra30.cpd33.03 \
        -background white \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* \
        -foreground black -height 1 -insertbackground black \
        -selectbackground black -selectforeground white -width 8 \
        -xscrollcommand {.top29.fra30.cpd33.01 set} \
        -yscrollcommand {.top29.fra30.cpd33.02 set} 
    frame $base.fra31 \
        -borderwidth 2 -height 75 -relief sunken -width 125 
    button $base.fra31.but32 \
        -command {Window hide [W HtmlHelpDialog]} -font menufont -padx 9 \
        -pady 3 -text OK 
    menu $base.m27 \
        -activeborderwidth 1 -borderwidth 1 -cursor {} -font lucidasans-12 
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.fra30 \
        -in .top29 -anchor center -expand 1 -fill both -padx 8 -pady 8 \
        -side top 
    pack $base.fra30.cpd33 \
        -in .top29.fra30 -anchor center -expand 1 -fill both -side top 
    grid columnconf $base.fra30.cpd33 0 -weight 1
    grid rowconf $base.fra30.cpd33 0 -weight 1
    grid $base.fra30.cpd33.01 \
        -in .top29.fra30.cpd33 -column 0 -row 1 -columnspan 1 -rowspan 1 \
        -sticky ew 
    grid $base.fra30.cpd33.02 \
        -in .top29.fra30.cpd33 -column 1 -row 0 -columnspan 1 -rowspan 1 \
        -sticky ns 
    grid $base.fra30.cpd33.03 \
        -in .top29.fra30.cpd33 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    pack $base.fra31 \
        -in .top29 -anchor center -expand 0 -fill x -padx 8 -pady 8 -side top 
    pack $base.fra31.but32 \
        -in .top29.fra31 -anchor center -expand 0 -fill x -padx 4 -pady 4 \
        -side top 
}

proc vTclWindow.top30 {base} {
    if {$base == ""} {
        set base .top30
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 342x416+287+234
    wm maxsize $base 1009 738
    wm minsize $base 132 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "Dimension Stacking Brush Toolbox"
    frame $base.01 \
        -borderwidth 1 -height 75 -relief sunken -width 125 
    frame $base.02 \
        -borderwidth 1 -height 75 -relief sunken -width 125 
    button $base.02.03 \
        -command {Window hide [W DimStackBrushDialog]} -font menufont -padx 9 \
        -pady 3 -text OK 
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.01 \
        -in .top30 -anchor center -expand 1 -fill both -padx 8 -pady 8 \
        -side top 
    grid columnconf $base.01 0 -weight 1
    grid columnconf $base.01 1 -weight 5
    grid rowconf $base.01 0 -weight 1
    grid rowconf $base.01 1 -weight 1
    grid rowconf $base.01 2 -weight 1
    pack $base.02 \
        -in .top30 -anchor center -expand 0 -fill x -padx 8 -pady 8 -side top 
    pack $base.02.03 \
        -in .top30.02 -anchor center -expand 0 -fill x -padx 4 -pady 4 \
        -side top 
}

proc vTclWindow.top31 {base} {
    if {$base == ""} {
        set base .top31
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 313x347+339+295
    wm maxsize $base 1265 994
    wm minsize $base 132 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "Parallel Coordinates Brush "
    frame $base.fra33 \
        -borderwidth 1 -height 27 -relief sunken -width 94 
    frame $base.fra34 \
        -borderwidth 1 -height 75 -relief sunken -width 125 
    button $base.fra34.01 \
        -command {Window hide [W ParallelCoordBrushDialog]} -font menufont \
        -padx 9 -pady 3 -text OK 
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.fra33 \
        -in .top31 -anchor center -expand 1 -fill both -padx 8 -pady 8 \
        -side top 
    pack $base.fra34 \
        -in .top31 -anchor center -expand 0 -fill x -padx 8 -pady 8 -side top 
    pack $base.fra34.01 \
        -in .top31.fra34 -anchor center -expand 0 -fill x -padx 4 -pady 4 \
        -side top 
}

proc vTclWindow.top32 {base} {
    if {$base == ""} {
        set base .top32
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 321x296+450+362
    wm maxsize $base 1265 994
    wm minsize $base 132 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "Dimension Stacking Key Dialog"
    frame $base.fra31 \
        -borderwidth 1 -height 75 -relief sunken -width 125 
    label $base.fra31.lab35 \
        -background gray -font menufont -relief raised \
        -text {Key for Dimension Stacking} 
    frame $base.fra31.fra36 \
        -borderwidth 1 -height 30 -relief raised -width 30 
    scrollbar $base.fra31.fra36.01 \
        -background gray -borderwidth 1 \
        -command {.top32.fra31.fra36.03 xview} -orient horiz \
        -troughcolor gray -width 10 
    scrollbar $base.fra31.fra36.02 \
        -background gray -borderwidth 1 \
        -command {.top32.fra31.fra36.03 yview} -orient vert -troughcolor gray \
        -width 10 
    text $base.fra31.fra36.03 \
        -background white -font fixedfont -foreground black -height 1 \
        -insertbackground black -selectbackground black \
        -selectforeground white -width 8 -wrap none \
        -xscrollcommand {.top32.fra31.fra36.01 set} \
        -yscrollcommand {.top32.fra31.fra36.02 set} 
    frame $base.fra33 \
        -borderwidth 1 -height 75 -relief sunken -width 125 
    button $base.fra33.but34 \
        -command {Window hide [W DimStackKeyDialog]} -font menufont -padx 9 \
        -pady 3 -text OK 
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.fra31 \
        -in .top32 -anchor center -expand 1 -fill both -ipadx 2 -ipady 2 \
        -padx 8 -pady 8 -side top 
    pack $base.fra31.lab35 \
        -in .top32.fra31 -anchor center -expand 0 -fill x -ipadx 4 -ipady 4 \
        -padx 4 -pady 4 -side top 
    pack $base.fra31.fra36 \
        -in .top32.fra31 -anchor center -expand 1 -fill both -padx 2 -pady 2 \
        -side top 
    grid columnconf $base.fra31.fra36 0 -weight 1
    grid rowconf $base.fra31.fra36 0 -weight 1
    grid $base.fra31.fra36.01 \
        -in .top32.fra31.fra36 -column 0 -row 1 -columnspan 1 -rowspan 1 \
        -sticky ew 
    grid $base.fra31.fra36.02 \
        -in .top32.fra31.fra36 -column 1 -row 0 -columnspan 1 -rowspan 1 \
        -sticky ns 
    grid $base.fra31.fra36.03 \
        -in .top32.fra31.fra36 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    pack $base.fra33 \
        -in .top32 -anchor center -expand 0 -fill x -padx 8 -pady 8 -side top 
    pack $base.fra33.but34 \
        -in .top32.fra33 -anchor center -expand 0 -fill x -padx 4 -pady 4 \
        -side top 
}

proc vTclWindow.top33 {base} {
    if {$base == ""} {
        set base .top33
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -menu .top33.m36 
    wm focusmodel $base passive
    wm geometry $base 313x1013+20+72
    wm maxsize $base 1265 994
    wm minsize $base 132 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "Auxillary Display"
    menubutton $base.men37 \
        -font menufont -indicatoron 1 -menu .top33.men37.m -padx 4 -pady 3 \
        -relief raised -text {Display Types} 
    menu $base.men37.m \
        -activeborderwidth 1 -borderwidth 1 -cursor {} -font menufont \
        -tearoff 0 
    $base.men37.m add command \
        \
        -command {[W m_auxillarydisplay] configure -text "Parallel Coordinates"
appRegisterCanvas auxillaryDisplayCanvas parcoord} \
        -label {Parallel Coordinates} 
    $base.men37.m add command \
        \
        -command {[W m_auxillarydisplay] configure -text "Scatterplots"
appRegisterCanvas auxillaryDisplayCanvas scatter} \
        -label Scatterplots 
    $base.men37.m add command \
        \
        -command {[W m_auxillarydisplay] configure -text "Glyphs"
appRegisterCanvas auxillaryDisplayCanvas glyphs} \
        -label Glyphs 
    $base.men37.m add command \
        \
        -command {[W m_auxillarydisplay] configure -text "Dimensional Stacking"
appRegisterCanvas auxillaryDisplayCanvas dimstack} \
        -label {Dimension Stacking} 
    $base.men37.m add command \
        \
        -command {[W m_auxillarydisplay] configure -text "Hierarchical Parallel Coordinates"
appRegisterCanvas auxillaryDisplayCanvas hierarchical} \
        -label {Hierarchical Dispays} 
    $base.men37.m add separator
    $base.men37.m add command \
        \
        -command {[W m_auxillarydisplay] configure -text "Tree Map"
appRegisterCanvas auxillaryDisplayCanvas treemap} \
        -label {Tree Map} 
    $base.men37.m add command \
        \
        -command {[W m_auxillarydisplay] configure -text "Structure-Based Brush"
appRegisterCanvas auxillaryDisplayCanvas cfNav} \
        -label {Structure-Based Brush} 
    $base.men37.m add command \
        \
        -command {[W m_auxillarydisplay] configure -text "Cluster Histogram"
appRegisterCanvas auxillaryDisplayCanvas cfHist} \
        -label {Cluster Histogram} 
    frame $base.fra34 \
        -borderwidth 1 -height 405 -relief sunken -width 291 
    frame $base.fra35 \
        -borderwidth 1 -height 75 -relief sunken -width 125 
    button $base.fra35.01 \
        -command {Window hide [W AuxillaryDisplayDialog]} -font menufont \
        -padx 9 -pady 3 -text OK 
    menu $base.m36 \
        -activeborderwidth 1 -borderwidth 1 -cursor {} -font menufont \
        -tearoff 0 
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.men37 \
        -in .top33 -anchor center -expand 0 -fill x -ipadx 4 -ipady 4 -padx 8 \
        -pady 8 -side top 
    pack $base.fra34 \
        -in .top33 -anchor center -expand 1 -fill both -padx 8 -pady 8 \
        -side top 
    pack $base.fra35 \
        -in .top33 -anchor center -expand 0 -fill x -padx 8 -pady 8 -side top 
    pack $base.fra35.01 \
        -in .top33.fra35 -anchor center -expand 0 -fill x -padx 4 -pady 4 \
        -side top 
}

proc vTclWindow.top34 {base} {
    if {$base == ""} {
        set base .top34
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -cursor xterm -menu .top34.08 
    wm focusmodel $base passive
    wm geometry $base 357x614+595+80
    wm maxsize $base 1265 994
    wm minsize $base 132 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "Data Values for Brushed Region"
    frame $base.01 \
        -borderwidth 1 -height 75 -relief sunken -width 125 
    frame $base.01.02 \
        -borderwidth 1 -height 30 -relief raised -width 30 
    scrollbar $base.01.02.03 \
        -background gray -borderwidth 1 -command {.top34.01.02.05 xview} \
        -orient horiz -troughcolor gray -width 10 
    scrollbar $base.01.02.04 \
        -background gray -borderwidth 1 -command {.top34.01.02.05 yview} \
        -orient vert -troughcolor gray -width 10 
    text $base.01.02.05 \
        -background white -font fixedfont -foreground black -height 1 \
        -insertbackground black -selectbackground black \
        -selectforeground white -width 8 -wrap none \
        -xscrollcommand {.top34.01.02.03 set} \
        -yscrollcommand {.top34.01.02.04 set} 
    frame $base.06 \
        -borderwidth 2 -height 75 -relief sunken -width 125 
    button $base.06.07 \
        -command {Window hide [W DataValuesDialog]} -font menufont -padx 9 \
        -pady 3 -text OK 
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.01 \
        -in .top34 -anchor center -expand 1 -fill both -padx 8 -pady 8 \
        -side top 
    pack $base.01.02 \
        -in .top34.01 -anchor center -expand 1 -fill both -side top 
    grid columnconf $base.01.02 0 -weight 1
    grid rowconf $base.01.02 0 -weight 1
    grid $base.01.02.03 \
        -in .top34.01.02 -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky ew 
    grid $base.01.02.04 \
        -in .top34.01.02 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
    grid $base.01.02.05 \
        -in .top34.01.02 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    pack $base.06 \
        -in .top34 -anchor center -expand 0 -fill x -padx 8 -pady 8 -side top 
    pack $base.06.07 \
        -in .top34.06 -anchor center -expand 0 -fill x -padx 4 -pady 4 \
        -side top 
}

proc vTclWindow.top39 {base} {
    if {$base == ""} {
        set base .top39
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 313x347+344+314
    wm maxsize $base 1009 738
    wm minsize $base 132 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "Glyph Brush Toolbox"
    frame $base.fra40 \
        -borderwidth 1 -height 75 -relief sunken -width 125 
    frame $base.fra41 \
        -borderwidth 1 -height 75 -relief sunken -width 125 
    button $base.fra41.but42 \
        -command {Window hide [W GlyphToolboxDialog]} -font menufont -padx 9 \
        -pady 3 -text OK 
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.fra40 \
        -in .top39 -anchor center -expand 1 -fill both -padx 8 -pady 8 \
        -side top 
    pack $base.fra41 \
        -in .top39 -anchor center -expand 0 -fill x -padx 8 -pady 8 -side top 
    pack $base.fra41.but42 \
        -in .top39.fra41 -anchor center -expand 0 -fill x -padx 4 -pady 4 \
        -side top 
}

proc vTclWindow.top40 {base} {
    if {$base == ""} {
        set base .top40
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -menu .top40.m20 
    wm focusmodel $base passive
    wm geometry $base 350x529+660+145
    wm maxsize $base 1265 994
    wm minsize $base 132 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "Cluster Hierarchy Toolbox"
    frame $base.fra20 \
        -borderwidth 1 -height 47 -relief sunken -width 282 
    frame $base.fra20.fra24 \
        -borderwidth 1 -height 92 -relief sunken -width 176 
    label $base.fra20.fra24.lab21 \
        -background gray -borderwidth 1 -font menufont -relief raised \
        -text {Dynamic Masking} 
    scale $base.fra20.fra24.sca26 \
        -command DynamicMaskingCmd -font menufont -from -1.0 \
        -highlightthickness 0 -orient horizontal -resolution 0.1 -takefocus 0 \
        -to 1.0 -variable fade_factor -width 13 
    frame $base.fra20.fra27 \
        -borderwidth 1 -height 64 -relief sunken -width 140 
    checkbutton $base.fra20.fra27.che28 \
        -command SetBandsOnOff -font menufont -highlightthickness 0 \
        -text {Show Bands} -variable show_bands 
    scale $base.fra20.fra27.sca29 \
        -command SetExtentScalingFactor -font menufont -highlightthickness 0 \
        -label {Extent Scaling} -orient horizontal -takefocus 0 \
        -variable extent_scaling_fac 
    frame $base.fra20.fra30 \
        -borderwidth 1 -relief sunken -width 116 
    label $base.fra20.fra30.lab35 \
        -background gray -borderwidth 1 -font menufont -relief raised \
        -text {Cluster Measure} 
    scale $base.fra20.fra30.sca36 \
        -activebackground #d9d9d9 -command SetClusterRadius -font menufont \
        -highlightthickness 0 -label Non-Brush -orient horizontal \
        -resolution 0.01 -takefocus 1 -to 1.0 -variable cluster_radius 
    scale $base.fra20.fra30.sca38 \
        -command SetBrushedRadius -font menufont -highlightthickness 0 \
        -label Brushed -orient horizontal -resolution 0.01 -takefocus 1 \
        -to 1.0 -variable brushed_radius 
    frame $base.fra20.fra17 \
        -borderwidth 2 -height 96 -relief groove -width 122 
    label $base.fra20.fra17.lab19 \
        -background gray -borderwidth 1 -font menufont -relief raised \
        -text {Dependent Dimension} 
    menubutton $base.fra20.fra17.men18 \
        -font menufont -indicatoron 1 -menu .top40.fra20.fra17.men18.m \
        -padx 4 -pady 3 -relief raised 
    menu $base.fra20.fra17.men18.m \
        -activeborderwidth 1 -borderwidth 1 -cursor {} -font menufont \
        -tearoff 0 
    button $base.fra20.but18 \
        -command {Window hide [W ClusterHierarchyDialog]} -font menufont \
        -padx 9 -pady 3 -text OK 
    frame $base.fra40 \
        -borderwidth 1 -height 247 -relief sunken -width 312 
    label $base.fra40.lab17 \
        -background gray -borderwidth 1 -font menufont -relief raised \
        -text {Structure-Based Brush} 
    frame $base.fra40.fra41 \
        -borderwidth 2 -height 180 -relief groove -width 151 
    label $base.fra40.lab18 \
        -background gray -borderwidth 1 -font menufont -relief raised \
        -text {Cluster Size Distribution} 
    frame $base.fra40.fra46 \
        -borderwidth 2 -height 76 -relief groove -width 154 
    label $base.fra40.lab19 \
        -background gray -borderwidth 1 -font menufont -relief raised \
        -text Treemap 
    frame $base.fra40.fra18 \
        -borderwidth 2 -height 131 -relief groove -width 156 
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.fra20 \
        -in .top40 -anchor n -expand 0 -fill y -padx 8 -pady 8 -side right 
    pack $base.fra20.fra24 \
        -in .top40.fra20 -anchor center -expand 0 -fill both -padx 2 -pady 4 \
        -side top 
    pack $base.fra20.fra24.lab21 \
        -in .top40.fra20.fra24 -anchor center -expand 0 -fill x -ipadx 2 \
        -ipady 2 -padx 2 -pady 2 -side top 
    pack $base.fra20.fra24.sca26 \
        -in .top40.fra20.fra24 -anchor n -expand 1 -fill x -side right 
    pack $base.fra20.fra27 \
        -in .top40.fra20 -anchor center -expand 0 -fill both -padx 2 -pady 4 \
        -side top 
    pack $base.fra20.fra27.che28 \
        -in .top40.fra20.fra27 -anchor center -expand 0 -fill none -ipady 2 \
        -side top 
    pack $base.fra20.fra27.sca29 \
        -in .top40.fra20.fra27 -anchor center -expand 0 -fill x -pady 10 \
        -side top 
    pack $base.fra20.fra30 \
        -in .top40.fra20 -anchor center -expand 1 -fill both -padx 2 -pady 4 \
        -side top 
    pack $base.fra20.fra30.lab35 \
        -in .top40.fra20.fra30 -anchor center -expand 0 -fill x -ipadx 2 \
        -ipady 2 -padx 2 -pady 2 -side top 
    pack $base.fra20.fra30.sca36 \
        -in .top40.fra20.fra30 -anchor center -expand 0 -fill x -side top 
    pack $base.fra20.fra30.sca38 \
        -in .top40.fra20.fra30 -anchor center -expand 0 -fill x -side top 
    pack $base.fra20.fra17 \
        -in .top40.fra20 -anchor center -expand 1 -fill both -side top 
    pack $base.fra20.fra17.lab19 \
        -in .top40.fra20.fra17 -anchor center -expand 0 -fill none -side top 
    pack $base.fra20.fra17.men18 \
        -in .top40.fra20.fra17 -anchor center -expand 0 -fill both -padx 4 \
        -pady 4 -side top 
    pack $base.fra20.but18 \
        -in .top40.fra20 -anchor center -expand 0 -fill x -padx 4 -pady 4 \
        -side top 
    pack $base.fra40 \
        -in .top40 -anchor center -expand 1 -fill both -padx 8 -pady 8 \
        -side top 
    pack $base.fra40.lab17 \
        -in .top40.fra40 -anchor center -expand 0 -fill x -ipady 2 -padx 4 \
        -pady 4 -side top 
    pack $base.fra40.fra41 \
        -in .top40.fra40 -anchor center -expand 1 -fill both -padx 4 -pady 2 \
        -side top 
    pack $base.fra40.lab18 \
        -in .top40.fra40 -anchor center -expand 0 -fill x -ipady 2 -padx 4 \
        -pady 4 -side top 
    pack $base.fra40.fra46 \
        -in .top40.fra40 -anchor center -expand 0 -fill both -padx 4 -pady 2 \
        -side top 
    pack $base.fra40.lab19 \
        -in .top40.fra40 -anchor center -expand 0 -fill x -ipady 2 -padx 4 \
        -pady 4 -side top 
    pack $base.fra40.fra18 \
        -in .top40.fra40 -anchor center -expand 0 -fill both -padx 4 -pady 4 \
        -side top 
}

Window show .
Window show .top17
Window show .top18
Window show .top19
Window show .top21
Window show .top22
Window show .top23
Window show .top24
Window show .top25
Window show .top26
Window show .top27
Window show .top28
Window show .top29
Window show .top30
Window show .top31
Window show .top32
Window show .top33
Window show .top34
Window show .top39
Window show .top40

main $argc $argv
